/***************************************************************************
 **
 ** (c) 1993,1994,1995 by Marc van Shaney , aka Kaya Memisoglu
 **
 ** This Source-Code was written by and is copyrighted by Kaya Memisoglu
 ** You may use the whole code or only parts of it in your own programs
 ** whether they are commercial or not. BUT you must give credits for these
 ** parts to me (Kaya Memisoglu  or  Marc van Shaney).
 ** I am not responsible for any damage or loss caused by this program, so
 ** if you success in erasing your harddisk with this code, then it is your
 ** own fault and you should not claim me to be responsible...
 ** I would be very pleased if you also sent me a postcard or even a letter
 ** if you can use this code. My address:
 **
 **        Kaya Memisoglu
 **        Reichenberger Ring 50
 **        63512 Hainburg
 **        Germany
 **
 ** You can also leave a message for Marc van Shaney on the Nirvana BBS:
 **
 **              Nirvana BBS     ++49-(0)6245-3056      Sysop:Raytrayza
 **
 **
 **/


#ifndef __EXT386_H
#define __EXT386_H

#ifndef NULL
 #define NULL                          0
#endif

#ifndef _SIZE_T
 #define _SIZE_T
 typedef unsigned size_t;
#endif


#ifndef _SIZE_L
 #define _SIZE_L
 typedef unsigned long size_l;
#endif


#ifndef _L_PTR
 #define _L_PTR
 typedef unsigned long l_ptr;
#endif

#ifndef TRUE
 #define TRUE                	1
 #define FALSE               	-1
 #define WRONG_TOKEN         	-10
 #define CONTINUE            	2
 #define FAIL                	-11
 #define ASK_ALWAYS          	3
 #define Success 		0
#endif

#define EXT_ALREADY_V86		-4
#define EXT_NO_HIMEM		-5
#define EXT_NO_386		-6
#define EXT_NO_XMS		-7
#define EXT_HIMEM_PROBLEM	-8
#define EXT_NO_DPMI		-9
#define EXT_NO_RAM		-10
#define EXT_NO_DPMI32		-11
#define EXT_MODIFIED		-12

#define EXT_EXIT_ON_LOWMEM	1L
#define EXT_DISPLAY_INFO	2L
#define EXT_USE_UMB		4L
#define EXT_EXIT_ON_RESET	8L
#define EXT_VERBOSE_RESET	16L
#define EXT_VERBOSE_PAUSE	32L

#ifndef PTR2LONG
#define PTR2LONG(a) (unsigned long)(((unsigned long)a & 0x0ffff0000L) >>12)+((unsigned long)a & 0x0ffffL)
#endif

extern void far *Malloc    (size_l);
extern int       Free      (void far *);
extern size_l    Coreleft  (void);
extern void far *DMA_Malloc(size_l);

extern int Init_EXT386(size_t io_buf_size,unsigned long flags);
extern int Exit_EXT386(void);

extern int    Creat(char *fname,int attrib);
extern int    Open (char *fname,int mode);
extern int    Close(int handle);
extern size_l Write(int handle,l_ptr src ,size_l len);
extern size_l Read (int handle,l_ptr dest,size_l len);
extern size_l Seek (int handle,size_l pos,int mode);
extern size_l Tell (int handle);
extern int    Chsize(int handle,size_l len);

extern l_ptr  EXT_Malloc   (size_l size);
extern int    EXT_Free    (l_ptr address);
extern size_l EXT_Coreleft(void);
extern l_ptr  EXT_DMA_Malloc (size_t size);
extern l_ptr  EXT_Page_Malloc (size_t size);

extern l_ptr Memcpy(l_ptr dest,l_ptr src ,size_l len);
extern int   Memcmp(l_ptr dest,l_ptr src ,size_l len);
extern l_ptr Memset(l_ptr dest,char c    ,size_l len);
extern l_ptr Memchr(l_ptr dest,char c    ,size_l len);

extern void *Get_Flat_Interrupt(int n);
extern void *Set_Flat_Interrupt(int n,void far *);
extern void *Get_Flat_Exception(int n);
extern void *Set_Flat_Exception(int n,void far *);
extern void *Get_Flat_IRQ(int n);
extern void *Set_Flat_IRQ(int n,void far *);
extern void *Get_Real_Interrupt(int n);
extern void *Set_Real_Interrupt(int n,void far *);

extern void *Get_PSP(void);

#endif