;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
;
;
;
;   GOMEZ DOS EXTENDER 						      v1.01
;
;
;
;
;
;
;Now for some improtanmt constants:
;	STACKSIZE		-	Size of main stack in paragraphs
;	INT_STACKSIZE		-	Size of interrupt stack in paragraphs
;	INT_STACKS		-	Number of nested interrupt stacks
;	FREE_DESCRIPTORS        -	Number of additional descriptors
;	FREE_TABLES		-	Number of additional page-tables
;	MIN_LOW_MEMORY		-	Minimal free low memory in kBytes
;	MIN_EXT_MEMORY		-	Minimal free extended memory in kBytes
;	IO_BUFFER_SIZE		-	Size of disk I/O buffer (in kBytes)
;	REFLECT_NMI		-	Reflects NMI-Interrupt to real-mode
;	GOMEZ_KEYBOARD		-	Enables own keyboard handler
;	GOMEZ_API		-	Enables INT21 API
;
;
GOMEZ_VERSION		equ	101h

STACKSIZE		equ	80h
INT_STACKSIZE		equ	10h
INT_STACKS		equ	8
FREE_DESCRIPTORS	equ	8
FREE_TABLES		equ	4
SYSTEM_DESCRIPTORS	equ	14
MIN_LOW_MEMORY		equ	60
MIN_EXT_MEMORY		equ	1500
IO_BUFFER_SIZE		equ	8
GOMEZ_KEYBOARD		equ	1
REFLECT_NMI		equ	1


;
;Now some equates for the selectors:
SEL_NULL		equ	0h
SEL_CODE32		equ     8h
SEL_DATA32             	equ     10h
SEL_STACK32            	equ     18h
SEL_CODE16		equ     20h
SEL_DATA16		equ     28h
SEL_REAL            	equ     30h
SEL_LINEAR		equ	38h
SEL_UDATA32		equ	40h
SEL_VCPITSS		equ	48h
SEL_VCPICODE            equ	50h 	;50h,58h,60h reserved for VCPI



.386P
LOCALS
JUMPS
GOMEZ_SYSTEM_FILE	equ	1

include		gomez.inc
include		keys.inc

b	equ	byte ptr
w	equ	word ptr
d	equ	dword ptr
o	equ	offset
s	equ	small

;
;
; First for some useful DOS-Malloc Macros...
;
; SysMalloc:
;   In:
;     BX  = Size in Paragraphs(16 bytes)
;   Out:
;     AX  = Segment address
;     EDX = Linear address
;
SysMalloc MACRO
	mov	ax,ds:[s DATA_End]
	add	ds:[s DATA_End],bx
	movzx 	edx,ax
	shl 	edx,4
       ENDM


SHRINK_MEM MACRO
	mov	eax,ds:[s PSP_Address]
	shr	eax,4
	mov	es,ax
	mov 	bx,ds:[s DATA_End]
	mov 	ax,es
	sub 	bx,ax
	mov 	ah,4Ah   ;resize memory block with PSP
	int 	21h      ;address in ES
	ENDM

;
;
; These two macros are used to control the NMI, which cannot be turned of
; with the cli-command.
;
NO_NMI MACRO
	in 	al,07fh
	or 	al,80h
	out 	07fh,al
	ENDM
YES_NMI MACRO
	in 	al,07fh
	and 	al,07fh
	out 	07fh,al
	ENDM





;
;   16BIT STARTUP CODE
;
.SEQ
code16  segment para public use16
code16  ends
code32  segment para public use32
code32  ends
codeend segment para stack use32 'stack'
codeend ends
udata32 segment para public use32
udata32 ends
uend    segment para public use32
uend    ends
code16  segment para public use16
	assume cs:code16, ds:code32
	smallstack
	org 0


	.8086				;Lets assume the worst case...
Boot16:	cli
	cld

	mov	ax,SEG CODEEND
	mov	ss,ax
	mov	sp,STACKSIZE*16		;Setup full stack

	mov	bx,SEG CODE32
	mov	ds,bx
	add	ax,(STACKSIZE+INT_STACKSIZE*INT_STACKS)+1
	mov	ds:[DATA_End],ax	;DATA_End points to end of program
					;DATA_End will be used to allocate
					;System-memory etc...
	push	es			;Save PSP for later...

	mov	ah,0fh
	int	10h		;Get current video-mode
	and	al,7eh
	cmp	al,2
	je	short VMODE_OK
	mov 	ax,0003 	;Set 80x25 text mode
	int 	10h
VMODE_OK:
;
	PSPHigh         equ     00002h
	PSPEnv          equ     0002ch
	PSPCmd          equ     00080h

	mov     ax, es:[PSPHigh]	; AX = Highest Memory Segment Addr
;	mov     bx, es:[PSPEnv] 	; BX = Environment Segment address
;	mov     _psp@, es       	; Keep Program Segment Prefix address
;	mov     _envseg@, bx    	; Keep Environment Segment address
	sub	ax,ds:[DATA_End]
	cmp     ax,MIN_LOW_MEMORY*64	;Is there anough free low memory ?
	jb	Low_Memory
;
	Cpu8086         equ     0
	Cpu80186        equ     1
	Cpu80286        equ     2
	Cpu80386        equ     3
	Cpu80486        equ     4
	Cpu80586	equ	5

	mov 	dx,Cpu8086	;Current processor is 8086
	push 	sp
	pop 	ax
	cmp 	sp,ax           ;Is AX equal to SP ?
	jne 	Wrong_CPU
	mov 	dx,Cpu80286
	pushf
	pop 	ax
	or 	ax,4000h
	push 	ax
	popf
	pushf
	pop 	ax
	test 	ax,4000h
	je 	Wrong_CPU
	.386P
	mov 	edx, Cpu80386
	mov 	ebx,esp
	and 	esp, 0FFFCh
	pushfd
	pop 	eax
	mov 	ecx,eax
	xor 	eax,00040000h
	push 	eax
	popfd
	pushfd
	pop 	eax
	and 	eax,00040000h
	and 	ecx,00040000h
	push	ecx
	popfd
	mov	esp,ebx
	cmp	eax,ecx
	je 	short @@Out
	mov 	edx,Cpu80486
	pushfd
	pop	ebx
	mov 	eax,ebx              	; try to flip ID bit in EFLAGS
	xor 	eax,200000h
	push 	eax                	; transfer EAX to EFLAGS
	popfd
	pushfd                          ; transfer EFLAGS back to EAX
	pop 	eax
	xor 	eax,ebx                 ; ID bit fliped?
	jz 	short @@Out		; if no, CPU is 486
	mov	edx,Cpu80586
@@Out: 	shl	edx,7
	or	ds:[s GOMEZ_System],edx	;Save CPU-Type in flags
;
	xor	ebx,ebx			; EBX = FPU-Type
	fninit                          ; reset FP status word
	mov     ds:[s FPU_Status],5a5ah	; initialize temp word to
					; non-zero value
	fnstsw 	ds:[s FPU_Status]      	; save FP status word
	fwait				; give some time to do so
	mov    	ax,ds:[s FPU_Status]	; check FP status word
	cmp     al,0                   	; see if correct status
	jne     end_check_fpu		; no fpu present
	fnstcw 	ds:[s FPU_Status]      	; save FP control word
	fwait				; delay a little
	mov     ax,ds:[s FPU_Status]   	; check FP control word
	and     ax,103fh                ; see if selected parts looks OK
	cmp     ax,3fh                  ; check that 1's & 0's
	jne     end_check_fpu		; no fpu present
	mov	ebx,4			; Set built-in FPU
	cmp	edx,Cpu80486 shl 7	; Is CPU=80486 or higher ???
	jae	end_check_fpu		; 386 ==> We have to check for 80287
	fwait
	fld1                            ; must use default control from FNINIT
	fldz                            ; form infinity
	fdiv                            ; 8087/80287 says +inf = -inf
	fld     st                      ; form negative infinity
	fchs                            ; 80387 says +inf <> -inf
	fcompp                          ; see if they are the same and remove them
	fstsw   ds:[s FPU_Status]      	; look at status from FCOMPP
	fwait
	mov     ax,ds:[s FPU_Status]
	mov	ebx,2			; store 80287 for fpu infinity
	fninit				; reinitialize FPU
	sahf                            ; see if infinities matched
	jz      end_check_fpu   	; jump if 8087/80287 is present
	mov     ebx, 3     		; store 80387 for fpu infinity
end_check_fpu:
	shl	ebx,11
	or	ds:[s GOMEZ_System],ebx	;Set flags
;
	mov	edi,OS_OS2              ;Assume IBM OS/2
	mov 	ah, 30h
	int 	21h  			;DOS version
	cmp 	al, 14h
	jae 	@Out2	 		;Jump if >= to 20
	mov	edi,OS_DESQVIEW		;Assume Desqview
	mov 	ax,2B01h
	mov 	cx,4445h
	mov 	dx,5351h
	int 	21h 			;Desqview Installed?
	cmp 	al, 255
	jne 	@Out2	 		;Jump if AL <> 255
	mov	edi,OS_WINDOWS         	;Assume MS Windows
	mov 	ax,160Ah
	int 	2Fh 			;Windows Install?
	cmp 	ax, 0h
	je 	@Out2	 		;If = Jump to Windows
	mov	edi,OS_DOS		;So it seems to be plain DOS
@Out2:	or	ds:[s GOMEZ_System],edi
;
	mov	bx,(FREE_DESCRIPTORS+SYSTEM_DESCRIPTORS+2)*8/16
	SysMalloc
	mov	ds:[s GDT32_Address],edx
	mov	es,ax				;ES points to GDT
	xor	di,di
	xor	eax,eax
	mov	cx,(FREE_DESCRIPTORS+SYSTEM_DESCRIPTORS+2)*4
	rep	stosw				;Clear GDT

	pop	ax				;Get PSP
	shl	eax,4
	mov 	ds:[s PSP_Address],eax		;Save PSP-segment

	mov	eax,cs                 		;16 bit code & data
	shl	eax,4
	mov	ds:[s CODE16_Address],eax
	MAKE_DESCRIPTOR16 DESC_CODE,0
	mov	es:[s SEL_CODE16],eax
	mov	es:[s SEL_CODE16+4h],edx
	mov	eax,ds:[s DATA16_Address]
	MAKE_DESCRIPTOR32 DESC_DATA,0
	mov	es:[s SEL_DATA16],eax
	mov	es:[s SEL_DATA16+4h],edx
	mov	eax,ds                        	;32 bit code & data
	shl	eax,4
	mov	ds:[s CODE32_Address],eax
	MAKE_DESCRIPTOR32 DESC_CODE,0
	mov	es:[s SEL_CODE32],eax
	mov	es:[s SEL_CODE32+4h],edx
	mov	eax,ds:[s DATA32_Address]
	MAKE_DESCRIPTOR32 DESC_DATA,0
	mov	es:[s SEL_DATA32],eax
	mov	es:[s SEL_DATA32+4h],edx
	mov	eax,ss				;32 bit stack segment
	shl	eax,4				; for 32-bit mode
	mov	ds:[s STACK32_Address],eax
	MAKE_DESCRIPTOR32 DESC_DATA,0
	mov	es:[s SEL_STACK32],eax
	mov	es:[s SEL_STACK32+4h],edx

	mov	dword ptr es:[s SEL_REAL],0ffffh
	mov	dword ptr es:[s SEL_REAL+4h],109200h
	mov	dword ptr es:[s SEL_LINEAR],0ffffh
	mov	dword ptr es:[s SEL_LINEAR+4h],0cf9200h
;
	push	ds
	pop	es				;ES = DATA32
	xor	ax,ax
	mov	fs,ax				;FS points to IDT
	mov	si,ax
	mov	di,SMALL OFFSET IDT_Copy       	;ES:DI points to dst-area
	mov	cx,256				;256 interrupts to save
	rep	movs dword ptr es:[di],fs:[si]	; . . . copy them !

	mov	bx,256*8/16			;Allocate memory for
	SysMalloc				;  protected mode IDT
	mov	ds:[s IDT32_Address],edx

	mov     bx,IO_BUFFER_SIZE*1024/16
	SysMalloc				;Allocate some I/O buffer
	mov	ds:[s IO_Buffer],edx	;   below 1MB
;
	in	al,021h				;IRQ-Mask of PIC0
	mov	ds:[s PIC0_State],al
	in	al,0A1h				;IRQ-MAsk of PIC1
	mov	ds:[s PIC1_State],al
;
	call 	Check_VCPI
	jc	short No2
	jmp	Use_VCPI
No2:	call	Check_XMS
	jc	short No3
	jmp	Use_XMS
No3:	call	Check_RAW
	jc	short No4
	jmp	Use_RAW
No4:	mov	dx,SMALL OFFSET ETXT1	;No system found => Error !
	jmp	Error16
;
Low_Memory:			;Not enough free low memory...
	mov	dx,SMALL OFFSET ETXT6
	jmp	Error16

Wrong_CPU:			;No 386+
	mov	dx,SMALL OFFSET ETXT5
	jmp	Error16		;Exit...

Error16:
	.8086			;Exit for non-80386
	mov 	ah,9		;DOS print string
	int 	21h
	mov	ax,-1		;Return code...
	.EXIT
	.386P
;
Exit_PMODE16:				;16 bit exit procedure
	cld				;String operation going forward
	mov	ax,SEG CODE32
	mov	ds,ax
	xor	di,di
	mov	es,di                   ;ES:DI points to real-mode IDT
	mov	si,SMALL OFFSET IDT_Copy;DS:SI points to copied IDT
	mov	cx,256
	rep	movsd                   ;Copy it !

	;
	;Lets restore the state of the PICs
	mov	al,ds:[s PIC0_State]
	out	021h,al
	mov	al,ds:[s PIC1_State]
	out	0A1h,al

			; set default timer interval into PIT0
	mov 	ax,36h 	; PIT channel 0, square wave,binary, send LSB & MSB
	out 	43h,al 	; send command
	mov 	al,0
	out 	40h,al 	; maximum timer count (freq. = 18.2 Hz)
	out 	40h,al 	;
	mov 	ax,0B6h	; PIT channel 2, square wave,binary, send LSB & MSB
	out 	43h,al 	; send command
	mov 	al,0
	out 	42h,al 	; maximum timer count (freq. = 18.2 Hz)
	out 	42h,al 	;
	in 	al,61h 	; disable sound
	and 	al,011111100b
	out 	61h,al

	YES_NMI
	sti
	xor	ax,ax		;Return code 0
	.EXIT



;
; SYSTEM-SPECIFIC INITIALISATION/EXIT CODE                           (XMS)
;
Check_XMS:
	mov	eax,cr0
	shr	al,1				;PM ???
	jc	short @@No_XMS

	mov 	ax,4300h
	int 	2fh                             ;Check for HIMEM.SYS
	cmp 	al,80h                          ;Check for XMS
	jne 	short @@No_XMS
	mov 	ax,4310h
	int 	2fh                             ;Get XMS-Handler
	mov 	word ptr ds:[s XMS_Control],bx
	mov 	word ptr ds:[s XMS_Control+2],es
	xor 	ax,ax                         	;Get Version
	call 	dword ptr ds:[s XMS_Control]
	cmp 	ax,200h                         ;Is it 2.00 or higher ???
	jb 	short @@No_XMS

	clc
	retn

 @@No_XMS:
	stc					;Carry => No XMS
	retn
;
Use_XMS:
	SHRINK_MEM				;Shrink memory used by program

	mov 	ax,0800h                    	;Get free XMS in kBytes
	call 	dword ptr ds:[s XMS_Control]
	movzx 	eax,ax				;Clear high-word
	shl 	eax,10                      	;*1kByte
	mov 	edx,eax                     	;Allocate all free XMS
	mov 	ds:[s HIMEM_Size],eax          	;Save size for memory-management
	cmp	eax,MIN_EXT_MEMORY*1024		;Is it enough ???
	jb	@@E1
	;

	mov 	ax,0900h                        ;Alloctae XMS
	shr 	edx,10				;Shift size (divide by 1kB)
	call 	dword ptr ds:[s XMS_Control]   	;Returns handle in DX
	test 	ax,ax
	jz 	short @@E1
	mov  	ds:[s XMS_Handle],dx          	;Save handle
	mov 	ax,0c00h                  	;Lock XMS
	call 	dword ptr ds:[s XMS_Control]   	;DX:BX holds linear Address
	shl 	edx,16
	mov 	dx,bx
	mov 	ds:[s HIMEM_Address],edx	;Save linear address here

	mov 	ah,03h				;Turn on A20
	call 	ds:[s XMS_Control]
	cmp	ax,1
	jne	@@E2
	;
	cli					;No interrupots please !
	NO_NMI
	or	ds:[s GOMEZ_System],METHOD_XMS
	mov	word ptr ds:[s Switch_to_PM],OFFSET XMSSwitch_to_PM
	mov	word ptr ds:[s Switch_to_RM],OFFSET XMSSwitch_to_RM
	mov	ebx,SEL_STACK32
	mov	edx,esp
	mov	edi,OFFSET Init_PMODE32
	jmp	ds:[s Switch_to_PM]
	;
 @@E1:  mov	dx,SMALL OFFSET ETXT2
	jmp	Error16
 @@E2:  mov 	dx,SMALL OFFSET ETXT3
	jmp	Error16
;
Exit_XMS:
	mov 	ax,0d00h                    	;Unlock XMS
	mov	dx,ds:[s XMS_Handle]   		;Get XMS-handle
	call 	dword ptr ds:[s XMS_Control]
	mov	dx,ds:[s XMS_Handle]
	mov 	ax,0a00h                    	;Free XMS
	call 	dword ptr ds:[s XMS_Control]
	mov 	ah,04h				;Disable A20
	call 	ds:[s XMS_Control]

	jmp	EXIT_PMODE16
;
; SYSTEM-SPECIFIC INITIALISATION/EXIT CODE                           (RAW)
;
;
;
; These routines use the AT-Interrupt 15h , function 88h
; Note that this technique may be incompatible and should not be used in
; every case. I heard that especially VDISK does not work with this method !
;
Check_RAW:
	mov	eax,cr0
	shr	al,1		;Carry will hold PM-bit
	retn
;
Use_RAW:
	SHRINK_MEM			;Free unneccessarry memory

	mov 	ah,88h                  ; chek and get extended mem
	int 	15h
	movzx 	eax,ax			;EAX holds free memory in kBytes
	shl 	eax,10
	cmp	eax,MIN_EXT_MEMORY*1024
	jb	@@E1
	mov 	ds:[s HIMEM_Size],eax
	mov 	ebx,100000h		;ATTENTION: DOES NOT WORK WITH VDISK !
	mov 	ds:[s HIMEM_Address],ebx

	call 	enableA20        	; enable that stupid A20 thingy
	jc 	@@E2			;Carry -> Error !
	;
	cli
	NO_NMI
	or	ds:[s GOMEZ_System],METHOD_RAW
	mov	word ptr ds:[s Switch_to_PM],OFFSET RAWSwitch_to_PM
	mov	word ptr ds:[s Switch_to_RM],OFFSET RAWSwitch_to_RM

	mov	ebx,SEL_STACK32
	mov	edx,esp
	mov	edi,OFFSET Init_PMODE32
	jmp	ds:[Switch_to_PM]
	;
 @@E1:  mov	dx,SMALL OFFSET ETXT2
	jmp	Error16
 @@E2:  mov 	dx,SMALL OFFSET ETXT3
	jmp	Error16
;
Exit_RAW:
	jmp 	EXIT_PMODE16

;
;
; These are some stupid A20 hardware-routines
; The credits for this part of the code must go to Thomas 'Tran' Pytel
; (Ripped from PMODE 2.4)
;
enableA20 PROC NEAR                     ; hardware enable gate A20
	xor ax,ax
	mov fs,ax
	dec ax
	mov gs,ax
	call testA20
	je short enableA20done

	in al,92h                       ; PS/2 A20 enable
	or al,2
	jmp short $+2
	jmp short $+2
	jmp short $+2
	out 92h,al
	call testA20
	je short enableA20done

	call enableA20o1                ; AT A20 enable
	jnz short enableA20wait
	mov al,0d1h
	out 64h,al
	call enableA20o1
	jnz short enableA20wait
	mov al,0dfh
	out 60h,al
	push offset enableA20wait
enableA20o1:
	mov ecx,20000h
enableA20o1l:
	jmp short $+2
	jmp short $+2
	jmp short $+2
	in al,64h
	test al,2
	loopdnz enableA20o1l
enableA20done:
	clc
	retn


enableA20wait:                          ; wait for A20
	mov al,36h
	out 43h,al
	xor al,al
	out 40h,al
	out 40h,al
	mov cx,800h
enableA20waitl0:
	call testA20
	je enableA20done
	in al,40h
	in al,40h
	mov ah,al
enableA20waitl1:
	in al,40h
	in al,40h
	cmp al,ah
	je enableA20waitl1
	loop enableA20waitl0

	stc
	retn
enableA20 ENDP

TestA20 PROC NEAR
	mov al,fs:[0]
	mov ah,al
	not al
	mov gs:[10h],al
	cmp ah,fs:[0]
	mov fs:[0],ah
	retn
TestA20 ENDP


;
; SYSTEM-SPECIFIC INITIALISATION/EXIT CODE                           (VCPI)
;
Check_VCPI:
	xor 	eax,eax
	mov 	gs,ax
	cmp 	gs:[4*67h],eax 	; NULL vector ?
	je 	short @@No
	;
	mov	dx,SMALL OFFSET EMM_Name
	mov	ax,3d00h	;Open device
	int	21h
	jc	short @@No

	mov	bx,ax
	mov	ax,4400h	;get device information
	int	21h
	jc	short @@No
	test	dl,80h
	jz	short @@No

	mov	ax,4407h	;check output status
	int	21h
	push	ax
	mov	ah,3eh		;close file
	int	21h
	pop	ax
	cmp	al,0ffh
	jne	short @@No
	;
	mov 	ax,0de00h       ;
	int 	67h             ;  Call VCPI INSTALLATION CHECK
	or 	ah,ah           ;
	jnz 	short @@No   	; if (ah != 0) it isn't VCPI
	clc
	retn
	;
@@No:	stc
	retn
;
Use_VCPI:
	mov	ax,0de03h		;get number of free pages
	int	67h
	cmp	edx,MIN_EXT_MEMORY/4
	jb	@@E1
	;
	mov 	ax,0de0ah     		;get PIC mappings
	int 	67h
	xor	di,di
@@L3:	mov	ds:[s IRQ_Flat_Slots+di],bl
	mov	ds:[s IRQ_Flat_Slots+di+8],cl
	inc	bl
	inc	cl
	inc	di
	cmp	di,8
	jb	short @@L3
	;
	mov	bx,7
	SysMalloc			;Allocate TSS
	mov	ds:[s TSS_Address],edx	;EDX = linear address of TSS
	mov	es,ax			;ES = segment of TSS
	xor 	di,di                  	;clear TSS with all 0, not really
	mov 	cx,34h                  ;  needed, but just to be safe
	xor 	ax,ax
	rep 	stosw

	mov	ebx,ds:[s GDT32_Address]
	shr	ebx,4
	mov	fs,bx			;FS = segment of GDT

	mov 	dword ptr fs:[SEL_VCPITSS+2],edx
	mov 	byte ptr fs:[SEL_VCPITSS],67h
	mov 	byte ptr fs:[SEL_VCPITSS+5],89h
	;
	movzx 	edx,ds:[s DATA_End]   	;align data area on page
	add 	dx,0ffh
	xor 	dl,dl                   ;DX = segment of page directory
	mov 	es,dx			;ES = pointer to page directory

	mov	eax,edx
	shl	eax,4                   ;EAX = linear address of page directory
	mov	ds:[s Page_Directory],eax

	xor 	di,di                   ;clear page dir and first page table
	mov 	cx,1000h
	xor 	ax,ax
	rep 	stosw
	;
	mov 	gs,dx                  	;GS = segment of page directory
	lea 	eax,[edx+100h]
	mov 	es,ax                  	;ES = segment of first page table
	mov 	fs,ax                   ;FS = segment of first page table

	mov	eax,ds:[s GDT32_Address];EAX = linear address of GDT
	shr	eax,4
	mov	ds,ax
	mov	si,SEL_VCPICODE		;DS:SI = ptr to three VCPI desciptors

	xor 	di,di                   ;ES:DI = ptr to first page table
	mov 	ax,0de01h		;get VCPI protected mode interface
	int 	67h
	test	ah,ah
	jnz	@@E2
	;
	mov	eax,SEG CODE32         	;DS = CODE32
	mov 	ds,ax

	mov 	ds:[s VCPI_calleip],ebx	;store protected mode VCPI call EIP
	shl	eax,4
	add	ds:[s VCPI_gdtaddx],eax
	add	ds:[s VCPI_idtaddx],eax
	add	ds:[s VCPI_structaddx],eax

	movzx 	si,dh                   ;SI = Segment address of page directory
	shl 	si,2                    ;SI = index in page-table
	lods 	dword ptr fs:[si]       ;EAX = Physical address of page directory
	and	ax,0f000h		;Mask out lower 12 Bits
	mov 	ds:[s VCPI_cr3],eax
	;
	push	es			;Save current page table
	mov	ebx,ds:[s TSS_Address]
	shr	ebx,4
	mov	es,bx			;ES = TSS segment

	mov 	es:[1ch],eax		;Save CR3 value in TSS
	mov 	d es:[64h],680000h  	;set offset of I/O permission bitmap
					;  and clear T bit
	pop	es			;ES:DI = unused page table entry
	;
	push	di
@@L0:	and 	byte ptr es:[di+1],0f1h	;clear bits 9-11 in copied page table
	sub 	di,4
	jnc 	@@L0
	pop	di			;ES:DI points to first unused entry

	movzx	eax,di			;EAX = address of first unused page
	shl	eax,10                  ;      in linear address space
	mov	ds:[s HIMEM_Address],eax
	mov	ds:[s HIMEM_Size],0
	;
	;Allocation of pages. Register allocation:
	;	GS	- segment of page directory
	;	FS	- segment of first page table
	;	ES	- segment of current page table
	;	DI	- index in current page table
	;	SI	- index to physical address of page tables
	;	EBX	- index in page directory
	;	ES	- segment of current page table
	;
	;Note on the available bits in the page table:
	;  	Bit 9	- allocated from VCPI server, has to be released
	;		  after exit
	;	Bit 10	- mapped into address space by Map_Memory
	;
	mov	bp,es			;BP = segment of current page table
	lods	dword ptr fs:[si]	;EAX = physical address of table
	mov	gs:[0],eax
	mov	ebx,1			;EBX = index in page directory
@@L1:	cmp	di,1000h
	jb	short @@J1
	add	bp,100h			;increment page table segment
	mov	es,bp			;ES = next segment
	xor	di,di
	mov	cx,800h
	xor	ax,ax
	rep	stosw			;Clear page-table
	xor	di,di			;ES:DI = ptr to first entry in table

@@L1F1:	lods 	dword ptr fs:[si]      	;EAX = physical address of page table
	mov 	gs:[ebx*4],eax         	;GS:EBX = ptr to page directory
	inc 	bx                     	;increment index in page directory

@@J1:   mov	ax,0de04h		;Allocate 4k page
	int	67h                     ;EDX = physical address of page
	test	ah,ah			;AH = 0 on success
	jnz	short @@ntbl		;No memory left...
	add	ds:[s HIMEM_Size],1 shl 12
	or	dx,207h			;Set present bit and bit 9 (available)
	mov	es:[di],edx		;Save physical address in page table
	add	di,4
	jmp	short @@L1
@@ntbl:	;
	if FREE_TABLES gt 0
	 mov	dx,FREE_TABLES
@@L2:	 add	bp,100h			;BP = ptr to next unused page
	 mov	es,bp			;ES = segment of current table
	 xor	di,di
	 xor	ax,ax
	 mov	cx,800h
	 rep	stosw			;Clear this table

	 lods	dword ptr fs:[si]	;EAX = physical address of table
	 mov	gs:[ebx*4],eax		;Save into directory
	 inc	bx			;Increment directory index

	 dec	dx
	 jnz	short @@L2
	endif
	;
	add	bp,100h			;BP = ptr to new unused low memory
	mov	ds:[s DATA_End],bp
	SHRINK_MEM
	;
	cli
	NO_NMI
	or	ds:[s GOMEZ_System],METHOD_VCPI
	mov	word ptr ds:[s Switch_to_PM],OFFSET VCPISwitch_to_PM
	mov	word ptr ds:[s Switch_to_RM],OFFSET VCPISwitch_to_RM

	mov	ebx,SEL_STACK32
	mov	edx,esp
	mov	edi,OFFSET Init_PMODE32
	jmp	ds:[s Switch_to_PM]
	;
@@E1:  	mov	dx,SMALL OFFSET ETXT2
	jmp	Error16
@@E2:	mov 	dx,SMALL OFFSET ETXT4
	jmp	Error16

;
Exit_VCPI:
	mov	ebx,ds:[s Page_Directory]
	shr	ebx,4			;EBX = ptr to page directory
	mov	fs,bx			;FS = segment of page directory
	add	bx,100h
	mov	es,bx			;ES = segment of first page table
	xor	si,si			;SI = index in page directory
	;
@@L1:	cmp	dword ptr fs:[si],0
	je	short @@End
	xor	di,di			;ES:DI = index in page table

@@L2:	mov	edx,es:[di]
	test	dh,2			;Bit 9 set ?   (Allocated page)
	jz	short @@J1
	and	dx,0f000h		;EDX = physical address
	mov	ax,0de05h
	int	67h			;Free this page

@@J1:	add	di,4			;Next entry in table
	cmp	di,1000h
	jb	short @@L2

	add	bx,100h			;increment page table pointer
	mov	es,bx			;ES = ptr to next page table
	add	si,4			;Advance to next entry in directory
	jmp	short @@L1
	;
@@End:  jmp	Exit_PMODE16

;
;
; This is the mode switching code code for XMS/RAW
;
; RAWSwicth_to_PM / XMSSwitch_to_PM:
;  Input:
;	DS	-	DATA32-Segment
;	ESI:EDI	-	New CS:EIP
;	EBX:EDX -	New SS:ESP
;  Output:
;	CS:EIP  -	Instruction pointer
;	SS:ESP	-	Stack
;      GDT	-	32bit PM GDT
;	IDT	-	32bit PM IDT
;	DS	-	CODE32 / DATA32 (Selector)
;
;
; RAWSwicth_to_RM / XMSSwitch_to_RM:
; Input:
;	DS	-	DATA32-Selector
;	SI:DI	-	New CS:IP
;	BX:DX	-	New SS:SP
; Output:
;	CS:IP	-	Instruction pointer
;	SS:SP	-	Stack
;	IDT	-	16bit RM IDT
;	DS	-	CODE32 / DATA32 (Segment)
;
RAWSwitch_to_PM:
XMSSwitch_to_PM:
	pushfd				;Save flags
	cli
	lgdt	fword ptr ds:[s GDT32_Limit]
	lidt	fword ptr ds:[s IDT32_Limit]
	pop	ecx			;ECX holds flags
	mov	eax,cr0
	or	al,1
	mov	cr0,eax			;Enable protected mode
	db 	0eah                    ;JMP FAR PTR SELCODE:$+4
	dw 	$+4,SEL_CODE16          ;  (clear prefetch que)
	mov	ds,ds:[s DATA32_Selector]
	mov	ss,bx
	mov	esp,edx			;Set new stack...
	xor	ax,ax
	mov	es,ax
	mov	fs,ax
	mov	gs,ax			;Clear other segment registers

	and 	ch,0bfh                 ; set NT=0 in old EFLAGS
	or	ch,30h			; set IOPL = 3
	push 	cx                      ; set current FLAGS
	popf
	push 	ecx                     ; store old EFLAGS
	push 	dword ptr ds:[s CODE32_Selector]
	push 	edi
	iretd                           ; go to targed addx in protected mode
;
XMSSwitch_to_RM:
RAWSwitch_to_RM:
	pushf
	pop	cx			;BX holds flags
	cli

	lidt	fword ptr ds:[s IDT16_Limit]
	mov 	ax,SEL_REAL             ;load descriptors with real mode seg
	mov 	ds,ax                   ;  attributes
	mov 	es,ax
	mov 	fs,ax
	mov 	gs,ax
	mov 	ss,ax
	and 	ch,0bfh                 ; set NT=0 in old EFLAGS
	or	ch,30h			; set IOPL = 3

	mov	eax,cr0
	and	al,NOT 1
	mov	cr0,eax                 ;Disable protected mode
	db 	0eah                    ;JMP FAR PTR PMODE_TEXT:$+4
	dw 	$+4,SEG CODE16          ;  (clear prefetch que)
	mov	ss,bx			;Setup new stack...
	movzx	esp,dx
	mov	ax,SEG CODE32		;make DS pointing to data-segment
	mov	ds,ax

	push	cx			;Save flags
	push    si			;Save segment
	push	di			;Save IP
	iret				;And go to real-mode

;
;
; This is the mode switching code code for VCPI
;
; VCPISwicth_to_PM:
;  Input:
;	DS	-	DATA32-Segment
;	ESI:EDI	-	New CS:EIP
;	EBX:EDX -	New SS:ESP
;  Output:
;	CS:EIP  -	Instruction pointer
;	SS:ESP	-	Stack
;      GDT	-	32bit PM GDT
;	IDT	-	32bit PM IDT
;	DS	-	CODE32 / DATA32 (Selector)
;
;
; VCPISwicth_to_RM
; Input:
;	DS	-	DATA32-Selector
;	SI:DI	-	New CS:IP
;	BX:DX	-	New SS:SP
; Output:
;	CS:IP	-	Instruction pointer
;	SS:SP	-	Stack
;	IDT	-	16bit RM IDT
;	DS	-	CODE32 / DATA32 (Segment)
;
VCPISwitch_to_PM:
	pushfw                          ;store FLAGS
	cli
	pop 	cx          		;CX = FLAGS
	mov 	esi,ds:[s VCPI_structaddx] 	;ESI = linear addx of VCPI structure
	mov 	ax,0de0ch               ;VCPI switch to protected mode
	int 	67h
v_rmtopmswpm:
	mov 	ss,bx                   ;load protected mode SS:ESP
	mov 	esp,edx
	mov	ax,SEL_DATA32
	mov 	ds,ax                	;load protected mode DS
	xor 	ax,ax
	mov	es,ax
	mov 	fs,ax                   ;load protected mode FS with NULL
	mov 	gs,ax                   ;load protected mode GS with NULL
	pushfd                          ;store EFLAGS
	and 	ch,0fh                  ; stack for IRETD
	mov 	[esp],cx
	push	d ds:[s CODE32_Selector]
	push 	edi                     ;store protected mode target EIP
	iretd                           ;go to target addx in protected mode
;
VCPISwitch_to_RM:
	pushfw                          ;store FLAGS
	pop	cx			;CX = flags
	cli
	xor	eax,eax
	and   	edx,0ffffh              ;clear high word of EDX, real mode SP
	and   	ebx,0ffffh              ;clear high word of EBX, real mode SS
	push	eax			;store real mode GS
	push	eax			;store real mode FS
	push	LARGE SEG CODE32	;store real mode DS
	push	eax			;store real mode ES
	push    ebx			;store real mode SS
	push    edx			;store real mode ESP
	push	eax			;reserved
	push    LARGE SEG CODE16	;store real mode CS
	push    LARGE OFFSET @@j1	;store real mode EIP
	mov	ds,ds:[s LIN_Selector]
	mov 	ax,0de0ch               ;VCPI switch to real mode (V86)
	call 	fword ptr cs:[s vcpi_calleip]
@@j1:	push 	cx                    	;store old FLAGS
	push 	si 			;store target CS in real mode
	push 	di 			;store target IP in real mode
	iret				;go to target addx in real mode


;
;   INTERRUPT/REDIRECTION RELATED REAL-MODE STUFF
;
PROC16START:				;This is used for (i)ret-PROC with
	mov	eax,ds:[s v86_EAX]	;  virtual registers
	mov	ebx,ds:[s v86_EBX]
	mov	ecx,ds:[s v86_ECX]
	mov	edx,ds:[s v86_EDX]
	mov	esi,ds:[s v86_ESI]
	mov	edi,ds:[s v86_EDI]
	mov	ebp,ds:[s v86_EBP]
	mov	es,ds:[s v86_ES]
	mov	fs,ds:[s v86_FS]
	mov	gs,ds:[s v86_GS]
	mov	ds,ds:[s v86_DS]	;Load all registers for real-mode call
	iret				;Jump to real-mode proc
PROC16END:
	push	ds			;Save DS from RM call
	pushfd				;Save flags
	push	SEG CODE32
	pop	ds			;DS=CODE32
	pop	ds:[s v86_EFLAGS]
	mov	ds:[s v86_EAX],eax	;Restore all virtual registers
	mov	ds:[s v86_EBX],ebx
	mov	ds:[s v86_ECX],ecx
	mov	ds:[s v86_EDX],edx
	mov	ds:[s v86_ESI],esi
	mov	ds:[s v86_EDI],edi
	mov	ds:[s v86_EBP],ebp
	mov	ds:[s v86_ES],es
	mov	ds:[s v86_FS],fs
	mov	ds:[s v86_GS],gs
	pop	word ptr ds:[s v86_DS]
	pop	ebx
	pop	edx			;EBX:EDX points to new stack
	pop	edi			;EDI holds dst-adr for return
	jmp	ds:[s Switch_to_PM]
;
IRQ16END:      				;This is used for fast iret-PROC
	mov	ax,SEG CODE32		;  without any virtual registers
	mov	ds,ax
	pop	ebx
	pop	edx			;EBX:EDX points to new stack
	pop	edi			;EDI points to return address
	jmp	ds:[s Switch_to_PM]
;
irpc unit,<0123456789abcdef>		;RM->PM IRQ redirectors
ReIRQ&unit:
	pushad
	mov	edi,OFFSET DUMMY_IRQ	;This address will be modified...
ReIRQAdr&unit:
	db	0e9h			;Jump NEAR instruction
	dw	ReIRQCommon16-ReIRQAdr&unit-3
endm

ReIRQCommon16:
	push	ds
	push	es
	push	fs
	push	gs
	mov	ax,SEG CODE32
	mov	ds,ax			;DS = DATA32 segment
	mov	ax,SEG codeend
	mov	es,ax			;ES = Stack segment
	mov	edx,ds:[s STACK_Top]
	sub	edx,16			;Make room for return values
	mov	ebx,SEL_STACK32		;EBX:EDX points to new stack
	add	ds:[s STACK_Top],INT_STACKSIZE*16

	;Prepare stack for restoring old stack-ptr
	mov	word ptr es:[edx+14],sp
	mov	word ptr es:[edx+12],ss

	pushfd
	pop	dword ptr es:[edx+8]	;Save flags on new stack
	mov	dword ptr es:[edx+4],SEL_CODE32
	mov	dword ptr es:[edx],OFFSET ReIRQEnd32
	jmp	ds:[s Switch_to_PM]

ReIRQEnd16:
	sub	ds:[s STACK_Top],INT_STACKSIZE*16
	pop	gs
	pop	fs
	pop	es
	pop	ds
	popad
	iret

code16  ends


;
;
;
;   GOMEZ                                      32BIT PROTECTED MODE KERNEL
;
;
;
;
;  Now here begins the 32-bit area...
;  First come some data-fields that are also used by the 16bit code
;  Note that these datas may NOT exceed 64k, because if they did, they were
;  not accessable any more from real-mode !
;
code32  segment para public use32
	assume cs:code32, ds:code32
	largestack
	org 0

PUBLIC C LIN_Selector   ,C CODE16_Selector ,C DATA16_Selector ,C CODE32_Selector
PUBLIC C DATA32_Selector,C STACK32_Selector,C UDATA32_Selector
PUBLIC C LIN_Address    ,C CODE16_Address  ,C CODE32_Address  ,C DATA16_Address
PUBLIC C DATA32_Address ,C STACK32_Address ,C UDATA32_Address ,C PSP_Address
PUBLIC C GDT32_Address  ,C IDT32_Address   ,C IDT16_Address
PUBLIC C HIMEM_Size     ,C HIMEM_Address
PUBLIC C GOMEZ_Flags    ,C GOMEZ_System

PUBLIC C V86_EAX	,C V86_AX	,C V86_AL	,C V86_AH
PUBLIC C V86_EBX	,C V86_BX	,C V86_BL	,C V86_BH
PUBLIC C V86_ECX	,C V86_CX	,C V86_CL	,C V86_CH
PUBLIC C V86_EDX	,C V86_DX	,C V86_DL	,C V86_DH
PUBLIC C V86_ESI	,C V86_SI
PUBLIC C V86_EDI	,C V86_DI
PUBLIC C V86_EBP	,C V86_BP
PUBLIC C V86_ESP	,C V86_SP
PUBLIC C V86_ES		,C V86_FS	,C V86_GS	,C V86_DS
PUBLIC C V86_EFLAGS	,C V86_FLAGS

PUBLIC C Init_PMODE32   	,C Exit_PMODE32
PUBLIC C Switch_to_RM    	,C Switch_to_PM
PUBLIC C Set_Real_Interrupt	,C Get_Real_Interrupt
PUBLIC C Set_Flat_Interrupt	,C Get_Flat_Interrupt
PUBLIC C Set_Flat_Exception	,C Get_Flat_Exception
PUBLIC C Set_Flat_IRQ	  	,C Get_Flat_IRQ
PUBLIC C Link_Real_IRQ	   	,C Unlink_Real_IRQ
PUBLIC C Invoke_Real_Int   	,C Invoke_Real_IRQ
PUBLIC C Call_Real_Proc	   	,C Call_Real_Int
PUBLIC C Enable_IRQ		,C Disable_IRQ

PUBLIC C Print32

PUBLIC C Scan_Argument		,C Scan_Environment

PUBLIC C Malloc			,C Free		,C Page_Malloc	,C Realloc
PUBLIC C DMA_Malloc		,C Coreleft 	,C Get_Size
PUBLIC C DOS_Malloc		,C DOS_Free	,C DOS_Coreleft
PUBLIC C DOS_DMA_Malloc
PUBLIC C Map_Memory		,C Unmap_Memory
PUBLIC C Alloc_Selector       	,C Free_Selector
PUBLIC C Set_Selector_Base     	,C Set_Selector_Rights
PUBLIC C Set_Selector_Limit	,C Get_Selector_Data

PUBLIC C Open		,C Close	,C Read		,C Write
PUBLIC C Creat		,C Tell		,C Seek		,C Chsize
PUBLIC C Getchar	,C Putchar	,C FindFile	,C Chdir

EXTRN  C main:NEAR

	;
	;First for some selector & address crap...
	;
	ALIGN 	DWORD
	LIN_Selector		dd	SEL_LINEAR
	CODE16_Selector		dd	SEL_CODE16
	DATA16_Selector		dd	SEL_DATA16
	CODE32_Selector		dd	SEL_CODE32
	DATA32_Selector		dd	SEL_DATA32
	STACK32_Selector	dd	SEL_STACK32
	UDATA32_Selector	dd	SEL_UDATA32

	LIN_Address		dd	0
	CODE16_Address		LABEL DWORD
	DATA16_Address		dd	?
	CODE32_Address		LABEL DWORD
	DATA32_Address		dd	?
	STACK32_Address		dd	?
	UDATA32_Address		dd	?
	PSP_Address		dd	?
	TSS_Address		dd	?

	PAGE_Directory		dd	?
	IO_Buffer		dd	?
	IDT_Copy		dd	256 dup (?)

	GOMEZ_Flags		dd	EXIT_ON_RESET or VERBOSE_PAUSE
	GOMEZ_System		dd	0

	HIMEM_Size		dd	0
	HIMEM_Address		dd	?
	STACK_Top		dd	(STACKSIZE+INT_STACKSIZE)*16
	DATA_End		dw	?

	Selector_Table		dd	(FREE_DESCRIPTORS+32)/32 dup (0)

	ALIGN WORD
	GDT32_Limit		dw	(2+FREE_DESCRIPTORS+SYSTEM_DESCRIPTORS)*8-1
	GDT32_Address		dd	?

	IDT16_Limit		dw	3ffh	;Real mode IDT
	IDT16_Address		dd	0
	IDT32_Limit		dw	7ffh	;Protected mode IDT
	IDT32_Address		dd	?



	ALIGN 4
	V86_EIP		LABEL DWORD
	V86_IP		dw	?,?
	V86_EFLAGS	LABEL DWORD
	V86_FLAGS	dw	?,?
	V86_EAX		LABEL DWORD
	V86_AX		LABEL WORD
	V86_AL		DB	?
	V86_AH		db	?,?,?
	V86_EBX		LABEL DWORD
	V86_BX		LABEL WORD
	V86_BL		DB	?
	V86_BH		db	?,?,?
	V86_ECX		LABEL DWORD
	V86_CX		LABEL WORD
	V86_CL		DB	?
	V86_CH		db	?,?,?
	V86_EDX		LABEL DWORD
	V86_DX		LABEL WORD
	V86_DL		DB	?
	V86_DH		db	?,?,?
	V86_ESP		LABEL DWORD
	V86_SP		dw	?,?
	V86_EBP		LABEL DWORD
	V86_BP		dw	?,?
	V86_ESI		LABEL DWORD
	V86_SI		dw	?,?
	V86_EDI		LABEL DWORD
	V86_DI		dw	?,?
	V86_ES		dw	?,0
	V86_CS		dw	?,0
	V86_SS		dw	?,0
	V86_DS		dw	?,0
	V86_FS		dw	?,0
	V86_GS		dw	?,0


	;
	;The following variables are routine-specific stuff
	ALIGN 	DWORD
	Switch_to_PM		LABEL DWORD
				dw	?,SEG CODE16
	Switch_to_RM            LABEL DWORD
				dw	?,SEL_CODE16

	KEYBOARD_Int		dd	?
	TIMER_Int		dd	?

	XMS_Control             dd      ?
	XMS_Handle              dw      ?

	VCPI_cr3        	dd      ?
	VCPI_gdtaddx    	dd      offset GDT32_Limit
	VCPI_idtaddx    	dd      offset IDT32_Limit
	VCPI_selldt     	dw      0               ; LDT selector for protected mode
	VCPI_seltss     	dw      SEL_VCPITSS     ; TSS selector for protected mode
	VCPI_eip        	dd      offset v_rmtopmswpm
	VCPI_cs         	dd      SEL_CODE16      ; destination CS in protected mode

	VCPI_calleip    	dd      ?               ; VCPI protected mode call offset
	VCPI_callcs     	dd      SEL_VCPICODE    ; VCPI protected mode call selector
	VCPI_structaddx		dd	OFFSET VCPI_cr3

	PIC0_State		db	?
	PIC1_State		db	?

	DOS_ASCII_Buffer	db	128 dup (?)

IRQ_Flat_Slots	db      8,9,0ah,0bh,0ch,0dh,0eh,0fh,70h,71h,72h,73h,74h,75h,76h,77h
IRQ_Real_Slots	db      8,9,0ah,0bh,0ch,0dh,0eh,0fh,70h,71h,72h,73h,74h,75h,76h,77h
FPU_Status	dw	?
EMM_Name	db	"EMMXXXX0",0
tempd0		LABEL	dword
tempw0		dw	?
tempw1		dw	?
tempd1		LABEL 	dword
tempw2		dw	?
tempw3		dw	?


HEADER	db	" Gomez - A 386-DOS Extender                          (C) 1996 by Kaya Memisoglu ",10,13,'$'

ETXT1	db	"GOMEZ: No VCPI,XMS or RAW start possible ! Please remove all memory managers.",10,13
	db	"       (QEMM,EMM386,Windows etc...)",10,13,'$'
ETXT2	db	"GOMEZ: Error allocating XMS memory. Possibly not enough free XMS ",10,13,'$'
ETXT3	db	"GOMEZ: Error enabling that A20 thing... Strange !",10,13,'$'
ETXT4	db	"GOMEZ: Error while initializing VCPI system.",10,13,'$'
ETXT5	db	"GOMEZ: You need at least a 386 processor !",10,13,'$'
ETXT6	db	"GOMEZ: Not enough conventional memory found",10,13,'$'


;
Init_PMODE32:				;We start here in 32bit PM
	pushfd                          ; set eflags: NT=0, IOPL=3
	pop 	eax
	and 	ah,0bfh
	or 	ah,30h
	push 	eax
	popfd
	;
	num=0				;Setup IRQ redirectors
	irpc unit,<0123456789abcdef>
		movzx	eax,ds:[IRQ_Real_Slots+num]
		call	Get_Real_Interrupt
		mov	dword ptr ds:[irqadr&unit-4],ebx
		num=num+1
	endm

	ifdef	REFLECT_NMI
	 mov	eax,2
	 call	Get_Real_Interrupt
	 mov	dword ptr ds:[NMI_Adr-4],ebx
	endif

	num=0				;Setup exception handlers
	irpc unit,<0123456789abcdefg>
		mov	eax,num
		mov	ebx,OFFSET Exception&unit
		call	Set_Flat_Exception
		num=num+1
	endm

	num=0				;Set IRQs to redirectors
	irpc unit,<0123456789abcdef>
		mov	eax,num
		mov	ebx,OFFSET irq&unit
		call	Set_Flat_IRQ
		num=num+1
	ENDM
	;
	ifdef GOMEZ_KEYBOARD
	 mov	eax,1
	 mov	ebx,OFFSET Keyboard_Handler
	 call	Set_Flat_IRQ
	 mov	ds:[KEYBOARD_Int],ebx
	 mov	eax,1
	 call	Link_Real_IRQ
	endif
	;
	mov	eax,ds:[PSP_Address]
	sub	eax,ds:[DATA32_Address]
	movzx	ecx,byte ptr ds:[eax+80h]	;ECX = len of command-line
	lea	ebx,[eax+81h]			;EBX = 1st char of command line
	@@L2:	cmp	byte ptr ds:[ebx+ecx],32
		ja	short @@Ok
		mov	byte ptr ds:[ebx+ecx],0
	@@Ok:	dec	ecx
		jns	short @@L2
	;
	mov 	es,ds:[LIN_Selector]
	mov 	ebx,ds:[HIMEM_Address]
	mov 	eax,ds:[HIMEM_Size]
	sub 	eax,16               	;Free size
	mov 	dword ptr es:[ebx],BLOCK_MAGIC
	mov	dword ptr es:[ebx+4],FREE_BLOCK or LAST_BLOCK
	mov 	dword ptr es:[ebx+8],eax
	;
	mov	ecx,SEG UEND
	sub	ecx,LARGE SEG UDATA32
	shl	ecx,4
	call	Malloc				;Allocate udata-segment
	mov	ds:[UDATA32_Address],eax
	mov	edi,ds:[GDT32_Address]
	MAKE_DESCRIPTOR32 DESC_DATA,0
	mov	es:[edi+SEL_UDATA32],eax
	mov	es:[edi+SEL_UDATA32+4h],edx
	;
@@NoUdata:
	mov	es,ds:[DATA32_Selector]		;Load FS and GS with linear
	mov	fs,ds:[LIN_Selector]		; selectors. DS is already loaded
	mov	gs,ds:[LIN_Selector]		; with DATA32_Selector

	sti
	YES_NMI

	jmp     main

;
Exit_PMODE32:				;Exit routine
	cld
	cli
	NO_NMI
	mov	ds,cs:[DATA32_Selector]
	mov	es,cs:[DATA32_Selector]
	mov	fs,cs:[DATA32_Selector]
	mov	gs,cs:[DATA32_Selector]
	mov	eax,ds:[GOMEZ_System]
	and	eax,7

	mov	bx,SEG codeend
	mov	dx,STACKSIZE*16		;Build new stack and destroy old !
	mov	si,SEG CODE16
	cmp	ax,METHOD_XMS
	jne	short PNo5
		mov 	di,offset Exit_XMS
		jmp	Doit
PNo5:	cmp	ax,METHOD_RAW
	jne	short PNo6
		mov 	di,offset Exit_RAW
		jmp	Doit
PNo6:	cmp	ax,METHOD_VCPI
	jne	short PNo7
		mov 	di,offset Exit_VCPI
		jmp	Doit
PNo7:
Doit:   push    dword ptr ds:[Switch_to_RM]
	db 	66h,0cbh               	; 16bit RETF go to 16bit stuff


;
;   GOMEZ   INTERRUPT REDIRECTORS  PM->RM  /  EXCEPTION HANDLING
;
DUMMY_IRQ:            		;Dummy: Just do nothing...
	push	eax
	mov	al,20h
	out	020h,al
	out	0a0h,al		;Set EOF to PICs
	pop	eax
	iretd
;
num=0
irpc unit,<0123456789abcdef>
irq&unit:
	pushad
	push 	ds
	push	es
	push	fs
	push	gs

	mov	eax,12345678h		;Real mode interupt address
irqAdr&unit:
	call    Call_Real_INT

	pop	gs
	pop	fs
	pop	es
	pop	ds
	popad
	iretd
	num=num+1
endm



ReIRQEnd32:
	mov	si,SEG CODE16
	mov	di,OFFSET ReIRQEnd16
	pop	bx
	pop	dx			;BX:DX points to old stack
	push   	dword ptr ds:[Switch_to_RM]
	db 	66h,0cbh               	; 16bit RETF go to 16bit stuff
;
ifdef GOMEZ_KEYBOARD
Keyboard_Handler:
	push 	eax
	push 	ebx
	push	ds
	push 	es
	cli
	mov	ds,cs:[DATA32_Selector]
	mov 	es,cs:[LIN_Selector]
	mov 	ah,es:[417h]

	in 	al,60h
	test 	ah,4                    ;Is 'Ctrl' pressed ???
	jz 	short @@4
	cmp 	al,0e0h                 ;Is it 'Pause' ???
	je 	short @@2
	cmp 	al,02eh                 ;Is it 'C' ???
	je 	short @@2
	cmp 	al,53h                  ;is it 'Del' ???
	jne 	short @@1
	test 	ah,8                    ;is Alt pressed ???
	jz 	short @@1

	test 	ds:[GOMEZ_Flags],EXIT_ON_RESET
	jnz 	short @@3
	test 	ds:[GOMEZ_Flags],VERBOSE_RESET
	jnz 	short @@2
	jmp 	short @@1

@@3:    and 	byte ptr es:[417h],NOT 4
	mov 	al,20h
	out 	20h,al
	mov	esi,OFFSET XTXT20
	jmp	Main_Exception_Handler

@@4:    test 	byte ptr es:[418h],8   	;Is it 'Pause' only ???
	jz 	short @@1
	test 	ds:[GOMEZ_Flags],VERBOSE_PAUSE
	jz 	short @@1
	and 	byte ptr es:[418h],0f7h  ;Clear pause flag
	mov 	al,20h
	out 	20h,al
	pop 	es
	pop	ds
	pop 	ebx
	pop 	eax
	iretd

@@1:	pop 	es
	pop	ds
	pop 	ebx
	pop 	eax
	jmp	cs:[KEYBOARD_Int]	;Chain into old interrupt

@@2:    and 	byte ptr es:[417h],NOT 4
	mov 	al,20h
	out 	20h,al
	pop 	es
	pop	ds
	pop 	ebx
	pop 	eax
	iretd
endif
;
XTXT0	db	"Exception 0: Division error (Fault)",10,13,'$'
XTXT1	db	"Exception 1: Debugger interrupt (Fault/Trap)",10,13,'$'
XTXT2	db	"Exception 2: NMI (Interrupt)",10,13,'$'
XTXT3	db	"Exception 3: Breakpoint (Trap)",10,13,'$'
XTXT4	db	"Exception 4: Overflow / INTO  (Trap)",10,13,'$'
XTXT5	db	"Exception 5: BOUND (Fault)",10,13,'$'
XTXT6	db	"Exception 6: Illegal opcode (Fault)",10,13,'$'
XTXT7	db	"Exception 7: Coprocessor not installed (Fault)",10,13,'$'
XTXT8	db	"Exception 8: Double-Fault (Abort)",10,13,'$'
XTXT9	db	"Exception 9: Segment overrun by NDP (Abort)",10,13,'$'
XTXTA	db	"Exception 10: Illegal TSS (Fault)",10,13,'$'
XTXTB	db	"Exception 11: Segment not in memory (Fault)",10,13,'$'
XTXTC	db	"Exception 12: Stack fault (Fault)",10,13,'$'
XTXTD	db	"Exception 13: General protection violation (Fault)",10,13,'$'
XTXTE	db	"Exception 14: Paging fault (Fault)",10,13,'$'
XTXTF	db	"Exception 15: ",10,13,'$'
XTXT10	db	"Exception 16: Coprocessor fault (Fault)",10,13,'$'
XTXT11	db	"Exception 17: Alignement fault (Fault)",10,13,'$'
XTXT20	db	"User-Exception: User hit Ctrl-Alt-Del",10,13,'$'
XTXT21  db	"Internal exception: Memory Control block destroyed",10,13,'$'
XTXTG	db	"   Gomez has been informed by the processor that something went not the way",10,13
	db	"   it should. The program will be terminated now. As a matter of fact your",10,13
	db	"   system may be extremly unstable now, so I suggest you to reboot your com-",10,13
	db	"   puter soon !  Don't tell me I didn't warn ya !",10,13,'$'


Exception0:
	mov	esi,OFFSET XTXT0
	jmp	Main_Exception_Handler
Exception1:
	mov	esi,OFFSET XTXT1
	jmp	Main_Exception_Handler
Exception2:
	ifdef	REFLECT_NMI
	 pushad
	 push 	ds
	 push	es
	 push	fs
	 push	gs

	 mov	eax,12345678h		;Real mode interupt address
NMI_Adr: call  	Call_Real_INT

	 pop	gs
	 pop	fs
	 pop	es
	 pop	ds
	 popad
	 iretd
	else
	 mov	esi,OFFSET XTXT2
	 jmp	Main_Exception_Handler
	endif
Exception3:
	mov	esi,OFFSET XTXT3
	jmp	Main_Exception_Handler
Exception4:
	mov	esi,OFFSET XTXT4
	jmp	Main_Exception_Handler
Exception5:
	mov	esi,OFFSET XTXT5
	jmp	Main_Exception_Handler
Exception6:
	mov	esi,OFFSET XTXT6
	jmp	Main_Exception_Handler
Exception7:
	mov	esi,OFFSET XTXT7
	jmp	Main_Exception_Handler
Exception8:
	mov	esi,OFFSET XTXT8
	jmp	Main_Exception_Handler
Exception9:
	mov	esi,OFFSET XTXT9
	jmp	Main_Exception_Handler
ExceptionA:
	mov	esi,OFFSET XTXTA
	jmp	Main_Exception_Handler
ExceptionB:
	mov	esi,OFFSET XTXTB
	jmp	Main_Exception_Handler
ExceptionC:
	mov	esi,OFFSET XTXTC
	jmp	Main_Exception_Handler
ExceptionD:
	mov	esi,OFFSET XTXTD
	jmp	Main_Exception_Handler
ExceptionE:
	mov	esi,OFFSET XTXTE
	jmp	Main_Exception_Handler
ExceptionF:
	mov	esi,OFFSET XTXTF
	jmp	Main_Exception_Handler
ExceptionG:
	mov	esi,OFFSET XTXT10
	jmp	Main_Exception_Handler
ExceptionH:
	mov	esi,OFFSET XTXT11
	jmp	Main_Exception_Handler
Main_Exception_Handler:
	NO_NMI
	cli
	cld

	mov	ds,cs:[DATA32_Selector]
	push	esi
	;
	;Now we will init a nice text-mode (standard 80x25) and we show
	;a nice header
	;
	mov 	ds:[v86_ax],0003 	; set 80x25 text mode
	mov	eax,10h
	call	Invoke_Real_Int
	mov 	ds:[v86_ah],2
	mov	ds:[v86_bh],0
	mov	ds:[v86_dx],0301h
	mov	eax,10h
	call	Invoke_Real_Int		;Set cursor

	mov	es,ds:[LIN_Selector]
	mov	edi,0b8000h 		;ES:EDI points to video RAM
	mov	esi,OFFSET HEADER       ;DS:ESI points to header
	mov	ah,4eh                  ;Colour code in AH
	mov	ecx,80
@@L1:	lodsb
	stosw				;Print header
	dec	ecx
	jnz	short @@L1

	pop	esi
	call	Print32
	mov	esi,OFFSET XTXTG
	call	Print32

	jmp	Exit_PMODE32
;
critical_error:                         ; some unrecoverable error
	cli                             ; make sure we are not interrupted
	in al,61h                       ; beep
	or al,3
	out 61h,al
	jmp $                           ; now hang
;
;
; The following routines are not really system routines. They are here for
; use by the user or for some screen I/O by GOMEZ. You can freely make use
; of them in your programs. Nothing special follows...
;
Print32 PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp
	mov	ds,cs:[DATA32_Selector]

	add	esi,ds:[CODE32_Address]
	mov	eax,esi
	and	esi,0fh
	shr	eax,4
	mov 	ds:[v86_ah],9
	mov	ds:[v86_edx],esi
	mov	ds:[v86_ds],ax
	mov	eax,21h
	call	Invoke_Real_Int		;Print DOS-String

	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
Print32 ENDP


;
;   HIGH-END USER CALLABLE FUNCTIONS		      IRQ/INTERRUPT-STUFF #1
;
;
;
; Now follow the IRQ/INT and EXCEPTION get/set-routines:
; 	Get_Real_Interrupt
; 	Set_Real_Interrupt
; 	Get_Flat_Interrupt
; 	Set_Flat_Interrupt
; 	Get_Flat_Exception
; 	Set_Flat_Exception
; 	Get_Flat_IRQ
; 	Set_Flat_IRQ
;
; All routines are 32bit and have the following interface:
; Get_Flat_Xxxxx:
;	In:
;	  AL=Number
;	Out:
;	  EBX=Address  (32bit offset within CODE32)
;
; Set_Flat_Xxxxx:
;	In:
;	  AL =Number
;	  EBX=Address  (32bit offset within CODE32)
;	Out:
;	  EBX=Address of old thing
;
; Get_Real_Xxxxx:
;	In:
;	  AL=Number
;	Out:
;	  EBX=Address  (SEGMENT:OFFSET)
;
; Set_Real_Xxxxx:
;	In:
;	  AL =Number
;	  EBX=Address  (SEGMENT:OFFSET)
;	Out:
;	  EBX=Address of old thing
;
; Link_Real_IRQ:
;	In:
;	  AL =Number
;	Out:
;	  EBX=Old SEG:OFFS address
;
; Unlink_Real_IRQ:
;	In:
;	  AL =Number
;	  EBX=Old SEG:OFFS address
;	Out:
;	  Nothing
;
; Note that all flat-mode handlers MUST end with an IRETD and all real
; mode handlers must end with a normal IRET !
;
;
Get_Flat_Interrupt:
	push	es
	mov	es,cs:[LIN_Selector]
	mov	ecx,cs:[IDT32_Address]
	movzx	eax,al

	mov	ebx,es:[ecx+8*eax]
	mov	edx,es:[ecx+8*eax+4]

	and	ebx,0ffffh
	and	edx,0ffff0000h
	or	ebx,edx

	pop	es
	retn
;
Set_Flat_Interrupt:
	push	es
	pushfd
	cli					;No INTs, please !

	movzx	eax,al				;Clear high-stuff
	mov	es,cs:[LIN_Selector]
	mov	ecx,cs:[IDT32_Address]
	push	dword ptr es:[ecx+8*eax]
	push	dword ptr es:[ecx+8*eax+4]	;Save old stuff for return
	mov	edx,ebx				;High word contains offset
	rol	ebx,16
	mov	bx,word ptr cs:[CODE32_Selector]
	rol	ebx,16				;EBX holds low-dword
	mov	dx,8000h+(15 shl 8)		;Present / CPL=0
	mov	es:[ecx+8*eax],ebx
	mov	es:[ecx+8*eax+4],edx

	pop	edx
	pop	ebx
	and	ebx,0ffffh
	and	edx,0ffff0000h
	or	ebx,edx

	popfd
	pop	es
	retn
;
Get_Flat_Exception:
	jmp	Get_Flat_Interrupt
;
Set_Flat_Exception:
	jmp	Set_Flat_Interrupt
;
Get_Real_Interrupt:
	push	es
	movzx	eax,al
	mov	es,cs:[LIN_Selector]
	mov	ebx,es:[4*eax]

	pop	es
	retn
;
Set_Real_Interrupt:
	push	es
	movzx	eax,al
	mov	es,cs:[LIN_Selector]
	xchg	ebx,es:[4*eax]

	pop	es
	retn
;
Get_Flat_IRQ:
	movzx	eax,al
	mov	al,cs:[IRQ_Flat_Slots+eax]
	jmp     Get_Flat_Interrupt
;
Set_Flat_IRQ:
	movzx	eax,al
	mov	al,cs:[IRQ_Flat_Slots+eax]
	jmp     Set_Flat_Interrupt
;
Link_Real_IRQ:
	push	ds
	push	es
	pushfd
	cli
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[LIN_Selector]
	mov	fs,ds:[DATA16_Selector]
	movzx	eax,al
	movzx	ecx,ds:[IRQ_Real_Slots+eax]	;ECX=Real Int-no
	movzx	edx,ds:[IRQ_Flat_Slots+eax]	;EDX=Flat int-no
	push	dword ptr es:[4*ecx]		;Get old IDT entry
	fastimul  ebx,eax,LARGE (OFFSET ReIRQ1 - OFFSET ReIRQ0)
	add	ebx,LARGE OFFSET ReIRQ0
	mov	word ptr es:[4*ecx],bx
	mov	word ptr es:[4*ecx+2],SEG CODE16

	mov	ecx,ds:[IDT32_Address]		;ECX=ptr to 32IDT
	mov	ax,es:[ecx+8*edx+6]		;High 16 bits
	shl	eax,16
	mov	ax,es:[ecx+8*edx]
	mov	dword ptr fs:[ebx + OFFSET ReIRQADR0 - OFFSET ReIRQ0 -4],eax

	pop	ebx				;Restore old IDT entry
	popfd
	pop	es
	pop	ds
	retn
;
Unlink_Real_IRQ:
	push	ds
	push	es
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[LIN_Selector]

	movzx	eax,al
	mov	al,ds:[IRQ_Real_Slots+eax]
	mov	dword ptr es:[4*eax],ebx	;Save old IDT entry

	mov	eax,TRUE
	pop	es
	pop	ds
	retn

;
;   HIGH-END USER CALLABLE FUNCTIONS		      IRQ/INTERRUPT-STUFF #2
;
;
;
; Enable_IRQ:
;   Input:
;	EAX	- IRQ-Number
;   Output:
;	CF	- Error-flag
;
; Disable_IRQ:
;   Input:
;	EAX	- IRQ-Number
;   Output:
;	CF	- Error-flag
;
Disable_IRQ:
	movzx	ebx,al
	cmp 	bl,7
	ja	short @@1
	in 	al,21h
	bts 	eax,ebx
	out 	21h,al
	clc
	retn
@@1:  	sub 	bl,8
	in 	al,0a1h
	bts 	eax,ebx
	out 	0a1h,al
	clc
	retn
;
Enable_IRQ:
	movzx	ebx,al
	cmp 	bl,7
	ja 	short @@1
	in 	al,21h
	btr 	eax,ebx
	out 	21h,al
	clc
	retn
@@1:  	sub 	bl,8
	in 	al,0a1h
	btr 	eax,ebx
	out 	0a1h,al
	clc
	retn


;
;   HIGH-END USER CALLABLE FUNCTIONS		      IRQ/INTERRUPT-STUFF #3
;
;
;
; The following function is used to invoke a DOS-interrupt in real-mode
; 	Invoke_Real_Int:
;		In:
;                 V86_xxx	-	Registers
;		   EAX		-	INT-No
;		Out:
;		   V86_xxx	-	Registers
;
Invoke_Real_Int:
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[LIN_Selector]
	mov	gs,ds:[STACK32_Selector]
	mov	eax,es:[4*eax]		;Get int-address...
	mov	si,SEG CODE16
	mov	di,OFFSET PROC16START	;SI:DI points to destination

	mov	edx,ds:[STACK_Top]
	sub	edx,24
	mov	ebx,SEG codeend		;EBX:EDX points to new stack
	add	ds:[STACK_Top],INT_STACKSIZE*16

	;Prepare stack for restoring old stack-ptr
	mov	dword ptr gs:[edx+20],OFFSET @@End
	mov	dword ptr gs:[edx+16],esp
	mov	dword ptr gs:[edx+12],ss

	;Prepare return from real-mode interrupt
	pushfw
	pop	word  ptr gs:[edx+10]
	mov	word  ptr gs:[edx+8 ],SEG CODE16
	mov	word  ptr gs:[edx+6 ],OFFSET PROC16END

	;Prepare jump to real-mode interrupt
	push	ds:[v86_flags]
	pop	word  ptr gs:[edx+4 ]
	mov	dword ptr gs:[edx   ],eax

	push    dword ptr ds:[Switch_to_RM]
	db 	66h,0cbh               	; 16bit RETF go to 16bit stuff

@@End:	sub	ds:[STACK_Top],INT_STACKSIZE*16
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
;
;
; The following function is used to invoke a DOS-interrupt in real-mode
; 	Invoke_Real_IRQ:
;		In:
;		   EAX		-	IRQ-number
;
; All registers will be saved !
;
Invoke_Real_IRQ:
	push	ds
	push	es
	push	fs
	push	gs
	pushad
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[LIN_Selector]
	mov	gs,ds:[STACK32_Selector]
	mov	al,ds:[IRQ_Real_Slots+eax]
	mov	di,es:[4*eax]		;Get int-address...
	mov	si,es:[4*eax+2]		;SI:DI points to RM-Interrupt
	mov	edx,ds:[STACK_Top]
	sub	edx,18
	mov	ebx,SEG codeend		;EBX:EDX points to new stack
	add	ds:[STACK_Top],INT_STACKSIZE*16

	;Prepare stack for restoring old stack-ptr
	mov	dword ptr gs:[edx+14],OFFSET @@End
	mov	dword ptr gs:[edx+10],esp
	mov	dword ptr gs:[edx+6],ss	;Save current stack address

	;Make RM iret return address
	pushfw
	pop	word  ptr gs:[edx+4]
	mov	word  ptr gs:[edx+2],SEG CODE16
	mov	word  ptr gs:[edx  ],OFFSET IRQ16END
	push    dword ptr ds:[Switch_to_RM]
	db 	66h,0cbh               	; 16bit RETF go to 16bit stuff

@@End:	sub	ds:[STACK_Top],INT_STACKSIZE*16
	popad
	pop	gs
	pop	fs
	pop	es
	pop	ds
	retn
;
;
; The following routine is used to invoke a real-mode RETF procedure
;
;	Call_Real_Proc:
;		In:
;		   EAX     - real mode SEG:OFFS address of RETF-procedure
;		   V86_xxx - registers/parameters
;		Out:
;		   V86_xxx - results
;		   Nothing
;
; Note that all registers will be saved.
;
Call_Real_Proc:
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp
	mov	ds,cs:[DATA32_Selector]
	mov	gs,ds:[STACK32_Selector]
	mov	si,SEG CODE16
	mov	di,OFFSET PROC16START
	mov	edx,ds:[STACK_Top]
	sub	edx,22
	mov	ebx,SEG codeend		;EBX:EDX points to new stack
	add	ds:[STACK_Top],INT_STACKSIZE*16

	;Prepare stack for restoring old stack-ptr
	mov	dword ptr gs:[edx+18],OFFSET @@End
	mov	dword ptr gs:[edx+14],esp
	mov	dword ptr gs:[edx+10],ss

	;Prepare return from real-mode procedure
	mov	word  ptr gs:[edx+8 ],SEG CODE16
	mov	word  ptr gs:[edx+6 ],OFFSET PROC16END

	;Prepare jump to real-mode interrupt
	push	ds:[v86_flags]
	pop	word  ptr gs:[edx+4 ]
	mov	dword ptr gs:[edx   ],eax

	push    dword ptr ds:[Switch_to_RM]
	db 	66h,0cbh               	; 16bit RETF go to 16bit stuff

@@End:	sub	ds:[STACK_Top],INT_STACKSIZE*16
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
;
;
; The following function is used to invoke a DOS-interrupt in real-mode
; 	Call_Real_Int:
;		In:
;		   EAX		-	Real-Mode SEG:OFFS of iret-proc
;
; Note that all registers will be destroyed. Only DS and SS:ESP will get
; reinitialized. So you have to care off all registers yourself...
;
Call_Real_Int:
	push	ds
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[LIN_Selector]
	mov	gs,ds:[STACK32_Selector]
	mov	edi,eax
	shld	esi,eax,16		;SI:DI points to RM-Interrupt
	mov	edx,ds:[STACK_Top]
	sub	edx,18			;Make some room for return values
	mov	ebx,SEG codeend		;EBX:EDX points to new stack
	add	ds:[STACK_Top],INT_STACKSIZE*16

	;Prepare stack for restoring old stack-ptr
	mov	dword ptr gs:[edx+14],OFFSET @@End
	mov	dword ptr gs:[edx+10],esp
	mov	dword ptr gs:[edx+6],ss	;Save current stack address

	;Make RM iret return address
	pushfw
	pop	word  ptr gs:[edx+4]
	mov	word  ptr gs:[edx+2],SEG CODE16
	mov	word  ptr gs:[edx  ],OFFSET IRQ16END
	push    dword ptr ds:[Switch_to_RM]
	db 	66h,0cbh               	; 16bit RETF go to 16bit stuff

@@End:	sub	ds:[STACK_Top],INT_STACKSIZE*16
	pop	ds
	retn



;
;  USER CALLABLE FUNCTIONS		              SELECTOR-STUFF
;
;
;
; Selector allocation/free etc... routines
;
; Alloc_Selector: (Makes a 4GB r/w selector)
;   In:
;   	EAX 	- Base
;   Out:
;    	EAX  	- Selector or 0
;
; Free_Selector:
;   In:
;   	EAX  	- Selector
;   Out:
;   	CF  	- Set on error
;
; Set_Selector_Base:
;  In:
;   	EAX 	- Selector
;	EBX	- Base address
;  Out:
;	CF	- Error flag
;
; Set_Selector_Limit:
;  In:
;   	EAX 	- Selector
;	EBX	- Limit
;  Out:
;	CF	- Error flag
;
; Set_Selector_Rights:
;  In:
;   	EAX 	- Selector
;	EBX	- Rights
;  Out:
;	CF	- Error flag
;
; Get_Selector_Data:
;  In:
;   	EAX 	- Selector
;  Out:
;      EAX	- Base (32 Bit linear address)
;	EBX	- Limit
;	ECX 	- Rights
;	CF	- Error flag
;
Alloc_Selector:
	push	ds
	push	es

	mov	ds,cs:[DATA32_Selector]
	mov	ebx,FREE_DESCRIPTORS-1         	;EBX = current selector
@@L1:	mov	edx,ebx				;
	mov	ecx,ebx
	shr	edx,5				;EDX = DWord-Index
	and	ecx,31				;ECX = Bit-Index
	bt	ds:[Selector_Table+4*edx],ecx
	jnc	short @@FOUND
	dec	ebx
	jns	short @@L1

	stc
	xor	eax,eax
	pop	es
	pop	ds
	retn

@@FOUND:
	bts	ds:[Selector_Table+4*edx],ecx	;Set bit
	lea	ebx,[8*ebx+8*SYSTEM_DESCRIPTORS]
	push	ebx				;EBX = selector to return

	add	ebx,ds:[GDT32_Address]
	mov	es,ds:[LIN_Selector]

	MAKE_DESCRIPTOR32 DESC_DATA,0		;Construct a descriptor
	mov	es:[ebx],eax
	mov	es:[ebx+4],edx

	clc
	pop	eax				;Get descriptor
	pop	es
	pop	ds
	retn
;
Free_Selector:
	push	ds
	mov	ds,cs:[DATA32_Selector]

	shr	eax,3			;Mask away stupid CPL etc..
	sub	eax,SYSTEM_DESCRIPTORS
	cmp	eax,FREE_DESCRIPTORS
	jae	short @@Err
	mov	ecx,eax
	shr	eax,5
	and	ecx,31
	btr	ds:[Selector_Table+4*eax],ecx

	clc
	pop	ds
	retn

@@Err:	stc
	pop	ds
	retn
;
Set_Selector_Base:
	push	ds
	mov	ds,cs:[DATA32_Selector]

	and	eax,0fff8h
	lea	ecx,[eax-8*SYSTEM_DESCRIPTORS]
	cmp	ecx,8*FREE_DESCRIPTORS
	jae	short @@Err		;Check selector range

	add	eax,ds:[GDT32_Address]
	sub	eax,ds:[DATA32_Address]	;DS:EAX points to GDT entry

	mov	ds:[eax+2],bx
	shr	ebx,16
	mov	ds:[eax+4],bl
	mov	ds:[eax+7],bh

	clc
	pop	ds
	retn

@@Err:	stc
	pop	ds
	retn
;
Set_Selector_Limit:
	push	ds
	mov	ds,cs:[DATA32_Selector]

	and	eax,0fff8h
	lea	ecx,[eax-8*SYSTEM_DESCRIPTORS]
	cmp	ecx,8*FREE_DESCRIPTORS
	jae	short @@Err		;Check selector range

	add	eax,ds:[GDT32_Address]
	sub	eax,ds:[DATA32_Address]	;DS:EAX points to GDT entry

	mov	ds:[eax],bx
	and	byte ptr ds:[eax+6],0f0h
	shr	ebx,16
	and	bl,0fh
	or	byte ptr ds:[eax+6],bl

	clc
	pop	ds
	retn

@@Err:	stc
	pop	ds
	retn
;
Set_Selector_Rights:
	push	ds
	mov	ds,cs:[DATA32_Selector]

	and	eax,0fff8h
	lea	ecx,[eax-8*SYSTEM_DESCRIPTORS]
	cmp	ecx,8*FREE_DESCRIPTORS
	jae	short @@Err		;Check selector range

	add	eax,ds:[GDT32_Address]
	sub	eax,ds:[DATA32_Address]	;DS:EAX points to GDT entry

	mov	byte ptr ds:[eax+5],bl
	and	byte ptr ds:[eax+6],0fh
	or	byte ptr ds:[eax+6],bh

	clc
	pop	ds
	retn

@@Err:	stc
	pop	ds
	retn
;
Get_Selector_Data:
	push	ds
	mov	ds,cs:[DATA32_Selector]

	and	eax,0fff8h
	lea	ecx,[eax-8*SYSTEM_DESCRIPTORS]
	cmp	ecx,8*FREE_DESCRIPTORS
	jae	short @@Err		;Check selector range

	add	eax,ds:[GDT32_Address]
	sub	eax,ds:[DATA32_Address]	;DS:EAX points to GDT entry

	mov	al,ds:[eax+4]
	mov	ah,ds:[eax+7]
	shl	eax,16
	mov	ax,ds:[eax]		;EAX = Base address
	mov	bl,byte ptr ds:[eax+6]
	and	ebx,0fh
	shl	ebx,16
	mov	bx,word ptr ds:[eax+2]	;EBX = Limit
	mov	cl,byte ptr ds:[eax+5] 	;CL = Rights I
	mov	ch,byte ptr ds:[eax+6]	;CH = Rights II
	and	ecx,0f0ffh

	clc
	pop	ds
	retn

@@Err:	stc
	pop	ds
	retn



;
;  USER CALLABLE FUNCTIONS		              MEMORY-MANAGEMENT
;
;
;
; The following routines are used to allocate some of the extended memory.
;
; The functions are:
; Malloc
;	In:
;	  ECX	- Size in Bytes
;	Out:
;	  EAX   - DATA32-Address
;	  CF    - Error flag
;
; Free
;	In:
;	  ECX	- DATA32-Address
;	Out:
;	  CF    - Error flag
;
; Get_Size
;	In:
;	  ECX	- DATA32-Address of allocated memory
;	Out:
;	  EAX	- Size of allocated block
;	  CF    - Error flag
;
; Realloc
;	In:
;	  EBX  	- DATA32-Address of allocated memory
;	  ECX	- New size of block
;	Out:
;	  EAX	- Address of resized block
;	  CF    - Error flag
;
; Coreleft
;	In:
;	  Nothing
;      Out:
;        EAX   - Total free HIMEM
;	  EDX   - Biggest free block in HIMEM
;
; DMA_Malloc
;	In:
;	  ECX	- Size in Bytes (max 64kB)
;	Out:
;	  EAX   - DATA32-Address
;	  CF    - Error flag
;
; Page_Malloc
;	In:
;	  ECX	- Number of pages (max 64kB)
;	Out:
;	  EAX   - DATA32-Address
;	  CF    - Error flag
;
; Alloc allocates a memory block with a specific size and returns the
; linear address. Free frees this memoryblock again, when you pass
; the address as a parameter. So they work exactly like malloc() and free()
;
; Our new memory is organzied like a single linked list,and each allocated
; memory block is described by a header:
;      dword Magic     -       'GURU'
;      dword Flags     -       Some flags (See below)
;      dword Size      -       Size WITHOUT header
;	dword ?
; The following flags are defined:
;      FREE_BLOCK      -       This block is available
;      LAST_BLOCK      -       This is the very last block in the list
; The first block is located at the very beginning of the allocated XMS.
; The next blocks can be found by adding the block-size plus 16 bytes for
; header information to the current address:
;
; Main Header
;   Magic
;   Flags
;   Size ------------->  Second Header
;   Data                   Magic
;                          Flags
;                          Size ----------(....)---> Last Header
;                          Data                        Magic
;                                                      Flags with LAST_BOCK
;                                                            set
;                                                      Size
;                                                      Data
;
;
Malloc PROC NEAR
	push	ds
	mov 	ds,cs:[DATA32_Selector] ;DS is your magic 4GB segment
	mov 	ebx,ds:[HIMEM_Address]  ;EBX points to first XMS-entry
	sub	ebx,ds:[DATA32_Address]
	add	ecx,15
	and	cl,0f0h			;Align to paragraphs

  @@Look_for_free:
	cmp 	dword ptr ds:[ebx],BLOCK_MAGIC
	jne 	@@Error                	;NO => XMS is corrupted !!!
	test 	dword ptr ds:[ebx+4],FREE_BLOCK
	jz 	short @@Block_not_free
	cmp 	ds:[ebx+8],ecx          ;Is free block large enough ?
	jb 	short @@Block_Not_Free  ;JB: Sorry,no !
	mov 	eax,ds:[ebx+8]          ;Save old size here
	and 	dword ptr ds:[ebx+4],NOT FREE_BLOCK
	sub 	eax,ecx                 ;Calculate remaining block size
	cmp 	eax,16                  ;When smaller than 16 bytes, do not
	jae 	short @@1            	;create a new block !!!

	lea 	eax,[ebx+16]		;Skip header for return address
	pop	es
	clc
	retn

  @@1:  mov 	ds:[ebx+8],ecx         	;Save new size
	mov 	edx,ebx                 ;Save for return value
	add 	ebx,16                 	;Skip over header
	add 	ebx,ecx                 ;New header will be placed here
	mov 	dword ptr ds:[ebx],BLOCK_MAGIC
	sub	eax,16                	;Subtract header-size from remaining size
	mov 	ds:[ebx+8],eax         	;Save new block size
	mov 	eax,FREE_BLOCK         	;Flag
	test 	dword ptr ds:[edx+4],LAST_BLOCK
	jz 	short @@2               ;JZ: It was NOT the last block
	or 	eax,LAST_BLOCK
  @@2:  mov 	ds:[ebx+4],eax       	;Save flags in new header
	and 	dword ptr ds:[edx+4],NOT LAST_BLOCK
	lea 	eax,[edx+16]		;Block address in EAX
	clc
	pop	es
	retn

  @@Block_Not_Free:
	test 	dword ptr ds:[ebx+4],LAST_BLOCK
	jnz 	short @@NoMem
	add 	ebx,ds:[ebx+8]
	add 	ebx,16
  jmp  @@Look_for_free


 @@Error:
	mov	esi,OFFSET XTXT21
	jmp	Main_Exception_Handler
 @@NoMem:
	xor 	eax,eax
	stc
	pop	ds
	retn
Malloc ENDP






DMA_Malloc PROC NEAR
	push	ds
	mov 	ds,cs:[DATA32_Selector]
	mov 	ebx,ds:[HIMEM_Address] 	;EBX points to first XMS-entry
	sub	ebx,ds:[DATA32_Address]
	add	ecx,15
	and	cl,0f0h			;Align to paragraphs

  @@Look_for_free:
	cmp 	dword ptr ds:[ebx],BLOCK_MAGIC
	jne 	@@Error                	;NO => XMS is corrupted !!!
	test	dword ptr ds:[ebx+4],FREE_BLOCK
	jz 	@@Block_not_free
	cmp 	ds:[ebx+8],ecx        	;Is free block large enough ?
	jb 	@@Block_Not_Free       	;JB: Sorry,no !
	;Now we have to est if there is a sub-block of memory in ONE page
	lea 	edx,[ebx+16]		;EDX = Current block address
	add	edx,ds:[DATA32_Address]	;EDX = Linear address
	mov 	eax,edx			;EAX = ditto
	shr 	eax,16                 	;Page
	add 	edx,ecx                	;Requested size
	shr 	edx,16
	cmp 	ax,dx                  	;Is it still same page
	jne 	@@Npage                	;JNE: No test next page

	;This is case 1:
	;  The first subblock is in one page
  @@Allocate:
	mov 	eax,ds:[ebx+8]          ;Save old size here
	and 	dword ptr ds:[ebx+4],NOT FREE_BLOCK
	sub 	eax,ecx                 ;Calculate remaining block size
	cmp 	eax,16                  ;When smaller than 16 bytes, do not
	jae 	short @@1               ;create a new block !!!

	;This is case 1a:
	;  The resulting second free block is smaller than 16 bytes and will
	;  be added to the allocated block
	lea 	eax,[ebx+16]          	;Skip header for return address
	clc
	pop	es
	retn

	;This is case 1b:
	;  The resulting block is larger than 16 bytes and a second free
	;  will be created
  @@1:  mov 	ds:[ebx+8],ecx     	;Save new size
	mov 	edx,ebx                 ;EDX = Block address (return value)
	lea	ebx,[ebx+ecx+16]	;EBX = Address of new header
	mov 	dword ptr ds:[ebx],BLOCK_MAGIC
	sub 	eax,8                   ;Subtract header-size from remaining size
	mov 	ds:[ebx+8],eax         	;Save new block size
	mov 	eax,FREE_BLOCK         	;Flag
	test 	dword ptr ds:[edx+4],LAST_BLOCK
	jz 	short @@2               ;JZ: It was NOT the last block
	or 	eax,LAST_BLOCK
  @@2:  mov 	ds:[ebx+4],eax         	;Save flags in new header
	and 	dword ptr ds:[edx+4],NOT LAST_BLOCK
	lea 	eax,[edx+16]
	clc
	pop	ds
	retn



	;Now we come to case 2:
	;  Here we check if the next page in the block can hold the requested
	;  memory-block
	;  EBX - current MCB
	;  ECX - requested size
  @@NPage:
	mov 	edx,ebx
	xor 	dx,dx           		;EDX points to next possible MCB
	add 	edx,10000h
	mov 	eax,ds:[ebx+8]
	sub 	eax,edx
	add 	eax,ebx             		;EAX= size of new block
	cmp 	eax,ecx
	jb 	short @@Block_Not_Free
	mov  	dword ptr ds:[edx],BLOCK_MAGIC
	mov 	dword ptr ds:[edx+8],eax    	;Set new size
	mov 	eax,ds:[ebx+4]          	;Get flags
	and  	dword ptr ds:[ebx+4],NOT LAST_BLOCK
	mov  	dword ptr ds:[edx+4],eax   	;Set flags
	mov 	eax,edx
	sub 	eax,ebx
	sub 	eax,16
	mov 	dword ptr ds:[ebx+8],eax    	;Set new size
	mov 	ebx,edx
	jmp 	@@Allocate


  @@Block_Not_Free:
	test 	dword ptr ds:[ebx+4],LAST_BLOCK
	jnz 	short @@NoMem
	add 	ebx,ds:[ebx+8]
	add 	ebx,16
  jmp  @@Look_for_free


 @@Error:
	mov	esi,OFFSET XTXT21
	jmp	Main_Exception_Handler
 @@NoMem:
	stc
	xor 	eax,eax
	pop	ds
	retn
DMA_Malloc ENDP






Page_Malloc PROC NEAR
	push	ds
	push	esi
	push	edi
	push	ebp

	mov 	ds,cs:[DATA32_Selector]	;ES is your magic 4GB segment
	mov 	ebx,ds:[HIMEM_Address]  ;EBX points to first XMS-entry
	sub	ebx,ds:[DATA32_Address]
	shl	ecx,12			; ... now in bytes

  @@Look_for_free:
	cmp 	dword ptr ds:[ebx],BLOCK_MAGIC
	jne 	@@Error                 ;NO => XMS is corrupted !!!
	test 	dword ptr ds:[ebx+4],FREE_BLOCK
	jz 	@@Block_not_free
	cmp 	ds:[ebx+8],ecx          ;Is free block large enough ?
	jb 	@@Block_Not_Free        ;JB: Sorry,no !
	;Now we have to test if there is a sub-block of memory in ONE page
	lea	ebp,[ebx+16]		;EBP points to first data-space
	lea 	edx,[ebp+4095]		;Get address plus one page
	and	dx,0f000h		;Align to next 4kB page
	sub	edx,ebp			;EDX holds size to skip
	jz	short @@Allocate	;EDX=0 => Allocate it !
	cmp	edx,16			;Is EDX>=16 ???
	jae	short @@1
	add	edx,4096		;Skip one additional page
  @@1:	lea 	eax,[edx+ecx]		;EAX holds new required size
	cmp	eax,ds:[ebx+8]		;Compare with free block size
	ja	@@Block_Not_Free


	;Now we come to case 2:
	;  Here we check if the next page in the block can hold the requested
	;  memory-block
	;  EBX - current MCB
	;  ECX - requested size
	;  EDX - size to skip between two headers
  @@NPage:
	sub	edx,16			;Subtract header size => EDX holds block size
	mov	eax,ds:[ebx+8]		;Get old size of this block
	mov	ds:[ebx+8],edx		;Save new size
	mov	esi,ds:[ebx+4]		;Get flags
	and  	dword ptr ds:[ebx+4],NOT LAST_BLOCK
	lea	ebx,[edx+ebx+16]	;Skip to next block
	sub	eax,edx			;Calc new remaining block-size
	sub	eax,16
	mov  	dword ptr ds:[ebx],BLOCK_MAGIC
	mov	dword ptr ds:[ebx+4],esi	;Save flags again
	mov 	dword ptr ds:[ebx+8],eax    	;Set new size


	;This is case 1:
	;  The first subblock is in one page
	;  EBX - current MCB
	;  ECX - requested size
  @@Allocate:
	mov 	eax,ds:[ebx+8]          ;Save old size here
	and 	dword ptr ds:[ebx+4],NOT FREE_BLOCK
	sub 	eax,ecx       		;Calculate remaining block size
	cmp 	eax,16                  ;When smaller than 16 bytes, do not
	jae 	short @@New             ;create a new block !!!

	;This is case 1a:
	;  The resulting second free block is smaller than 16 bytes and will
	;  be added to the allocated block
	lea 	eax,[ebx+16]		;Skip header for return address
	clc
	pop	ebp
	pop	edi
	pop	esi
	pop	ds
	retn

	;This is case 1b:
	;  The resulting block is larger than 16 bytes and a second free
	;  will be created
	;  EBX - current MCB
	;  EAX - remaining block size
	;  ECX - size to allocate
 @@New:	mov 	ds:[ebx+8],ecx         	;Save new size
	mov 	edx,ebx                	;Save for return value
	lea 	ebx,[ebx+ecx+16]       	;Skip over header
	mov 	dword ptr ds:[ebx],BLOCK_MAGIC
	sub 	eax,16                 	;Subtract header-size from remaining size
	mov 	ds:[ebx+8],eax         	;Save new block size
	mov 	eax,FREE_BLOCK         	;Flag
	test 	dword ptr ds:[edx+4],LAST_BLOCK
	jz 	short @@2              	;JZ: It was NOT the last block
	or 	eax,LAST_BLOCK
  @@2:  mov 	ds:[ebx+4],eax         	;Save flags in new header
	and 	dword ptr ds:[edx+4],NOT LAST_BLOCK
	lea	eax,[edx+16]
	clc
	pop	ebp
	pop	edi
	pop	esi
	pop	ds
	retn


	;
	;Here we proceed to the next block
	;
  @@Block_Not_Free:
	test 	dword ptr ds:[ebx+4],LAST_BLOCK
	jnz 	short @@NoMem
	add 	ebx,ds:[ebx+8]
	add 	ebx,16
  jmp  @@Look_for_free


 @@Error:
	mov	esi,OFFSET XTXT21
	jmp	Main_Exception_Handler
 @@NoMem:
	xor 	eax,eax
	stc
	pop	ebp
	pop	edi
	pop	esi
	pop	ds
	retf
Page_Malloc ENDP






Free PROC NEAR
	push	ds
	mov 	ds,cs:[DATA32_Selector]
	mov 	ebx,ds:[HIMEM_Address]
	sub	ebx,ds:[DATA32_Address]
	sub 	ecx,16                 	;Jump back to header
	xor 	edx,edx                 ;EDX will hold last-block
 @@Search_Block:
		cmp 	dword ptr ds:[ebx],BLOCK_MAGIC
		jne	@@Error
		cmp 	ebx,ecx
		je 	short @@Block_Found
		mov 	edx,ebx             	;Save last-block for collecting
		test 	dword ptr ds:[ebx+4],LAST_BLOCK
		jnz 	short @@4
		add 	ebx,ds:[ebx+8]
		add 	ebx,16           	;Jump to next header
 jmp short @@Search_Block
 @@4:   stc
	pop	ds
	retn

@@Block_Found:
	test 	edx,edx                 ;Is Last_Block=Zero ?
	jz 	short @@No_Previous_Block
	test 	dword ptr ds:[edx+4],FREE_BLOCK
	jz 	short @@No_Previous_Block
	test 	dword ptr ds:[ebx+4],LAST_BLOCK
	pushfd
	mov 	eax,ds:[ebx+8]
	add 	eax,16              	;EAX has block-size inclusive header
	mov 	ebx,edx                 ;EBX points to previous block
	add 	ds:[ebx+8],eax         	;Adjust size
	mov 	eax,FREE_BLOCK
	popfd
	jz 	short @@1              	;Was it the last block ?
	or 	eax,LAST_BLOCK         	;Yes,then this is the last block,too
   @@1: mov 	ds:[ebx+4],eax         	;Save flags

@@No_Previous_Block:
	test 	dword ptr ds:[ebx+4],LAST_BLOCK
	jnz 	short @@One_Block
	mov 	edx,ebx
	add 	edx,ds:[ebx+8]
	add 	edx,16                	;EDX points to next block-header
	test 	dword ptr ds:[edx+4],FREE_BLOCK
	jz 	short @@One_Block
	test 	dword ptr ds:[edx+4],LAST_BLOCK
	pushfd
	mov 	eax,ds:[edx+8]     	;Get block-size
	add 	eax,16                 	;Add header-size
	add 	ds:[ebx+8],eax        	;Add block-size to current block
	mov 	eax,FREE_BLOCK
	popfd
	jz 	short @@2
	or 	eax,LAST_BLOCK
   @@2: mov 	ds:[ebx+4],ax          	;Save flags

	clc
	pop	ds
	retn

@@One_Block:
	or 	dword ptr ds:[ebx+4],FREE_BLOCK
	clc
	pop	ds
	retn

@@Error:mov	esi,OFFSET XTXT21
	jmp	Main_Exception_Handler
Free ENDP





Coreleft PROC NEAR
	push	ds
	mov 	ds,cs:[DATA32_Selector]

	mov 	ebx,ds:[HIMEM_Address]
	sub	ebx,ds:[DATA32_Address]
	xor 	eax,eax
	xor	edx,edx
 @@Loop:
		cmp 	dword ptr ds:[ebx],BLOCK_MAGIC
		jne 	short @@Err
		test 	dword ptr ds:[ebx+4],FREE_BLOCK
		jz 	short @@1
		add 	eax,ds:[ebx+8]		;Add to total free HIMEM
		cmp     edx,ds:[ebx+8]		;Check for biggest free block
		jae	short @@1
		mov	edx,ds:[ebx+8]		;Set new biggest free block
	  @@1:  test 	dword ptr ds:[ebx+4],LAST_BLOCK
		jnz 	short @@End		;Last block ???
		add 	ebx,ds:[ebx+8]		;Skip to next block !
		add 	ebx,16
 jmp short @@Loop

@@End:  clc
	pop	ds
	retn
@@Err:  mov	esi,OFFSET XTXT21
	jmp	Main_Exception_Handler
Coreleft ENDP





Get_Size PROC NEAR
	push	ds
	mov 	ds,cs:[DATA32_Selector]
	mov 	ebx,ds:[HIMEM_Address] 	;Start for search
	sub	ebx,ds:[DATA32_Address]
	sub 	ecx,16                 	;Jump back to header
 @@Search_Block:
		cmp 	dword ptr ds:[ebx],BLOCK_MAGIC
		jne	@@Err			;Oha - strange magic !
		cmp 	ebx,ecx			;Is it this address ???
		je 	short @@Block_Found
		test 	dword ptr ds:[ebx+4],LAST_BLOCK
		jnz 	short @@N
		add 	ebx,ds:[ebx+8]		;Skip this block...
		add 	ebx,16           	;Jump to next header
 jmp short @@Search_Block
 @@N: 	xor 	eax,eax				;Return zero as size !
	stc
	pop	ds
	retn

 @@Block_Found:
	mov	eax,ds:[ebx+8]			;Get size of this block
	clc
	pop	ds
	retn
 @@Err:	mov	esi,OFFSET XTXT21
	jmp	Main_Exception_Handler
Get_Size ENDP






Realloc PROC NEAR
	push	ds
	push	es
	mov 	ds,cs:[DATA32_Selector]
	mov 	es,cs:[DATA32_Selector]
	mov 	edx,ds:[HIMEM_Address]
	sub	edx,ds:[DATA32_Address]
	sub 	ebx,16                 		;EBX = header of old block
	add	ecx,15                          ;ECX = new size
	and	cl,0f0h				;Align to 16byte borders
 @@Search_Block:
		cmp 	dword ptr ds:[edx],BLOCK_MAGIC
		jne	@@Err
		cmp 	edx,ebx			;Same block ???
		je 	short @@Block_Found
		test 	dword ptr ds:[edx+4],LAST_BLOCK
		jnz 	@@No
		add 	edx,ds:[edx+8]
		add 	edx,16           	;Jump to next header
 jmp short @@Search_Block

@@Block_Found:
	cmp	ecx,ds:[ebx+8]
	je	@@End
	ja	@@Expand

	;
	;Here we have to shrink the block !
	;
	test	dword ptr ds:[ebx+4],LAST_BLOCK
	jnz	short @@Create_new_Block
	lea	edx,[ebx+16]
	add	edx,ds:[ebx+8]			;EDX points to following block
	cmp	dword ptr ds:[edx],BLOCK_MAGIC
	jne	@@Err
	test	dword ptr ds:[edx+4],FREE_BLOCK
	jz	short @@Create_New_Block

	;
	;Now we will attach the remaining bytes from the old block to
	;the following (and free) block...
	;
	push	ebx				;Save current address
	mov	eax,ds:[edx+4]			;Get Header flags
	xchg	dword ptr ds:[ebx+8],ecx	;Save new size
	sub	ecx,ds:[ebx+8]			;Get new empty size
	mov	ebx,ds:[edx+8]			;Get old size of foll. block
	sub	edx,ecx                         ;Move header
	mov	dword ptr ds:[edx],BLOCK_MAGIC
	mov	ds:[edx+4],eax			;Save new header flags
	add	ebx,ecx				;Adjust block size
	mov	ds:[edx+8],ebx			;Save block size
	pop	ebx
	jmp	@@End

	;
	;Here we will create a new block that will be free...
	;
@@Create_New_Block:
	mov	eax,ds:[ebx+8]
	sub	eax,ecx				;Get size delta
	cmp	eax,16				;Difference smaller 16 ???
	jbe	@@End
	push	dword ptr ds:[edx+4]		;Save flags
	and	dword ptr ds:[edx+4],NOT LAST_BLOCK
	mov	ds:[ebx+8],ecx			;Save new size
	lea	edx,[ebx+ecx+16]		;EDX points to new header
	sub 	eax,16				;Subtract header size from delta
	mov	dword ptr ds:[edx],BLOCK_MAGIC
	pop	dword ptr ds:[edx+4]		;Restore flags
	or	dword ptr ds:[edx+4],FREE_BLOCK
	mov	ds:[edx+8],eax			;Save size of new header
	jmp	@@End

	;
	;Here we want to create a bigger block
	;
@@Expand:
	test	dword ptr ds:[ebx+4],LAST_BLOCK
	jnz	short @@Alloc_new_Block
	lea	edx,[ebx+16]                    ;EDX = ptr to new block
	add	edx,ds:[ebx+8]			;EDX points to following block
	cmp	dword ptr ds:[edx],BLOCK_MAGIC
	jne	@@Err
	test	dword ptr ds:[edx+4],FREE_BLOCK
	jz	short @@Alloc_New_Block

	;
	;Here we try to expand the current block...
	;
	lea	eax,[ecx-16]
	sub	eax,ds:[ebx+8]			;Block-size needed
	cmp	ds:[edx+8],eax			;Is there enough memory ???
	jb	short @@Alloc_New_Block

	push	dword ptr ds:[edx+4]		;Save flags
	mov	eax,ds:[edx+8]			;Get size of following block
	add	eax,ds:[ebx+8]			;Get total size of block
	add	eax,16				;EAX=block size of current+foll.
	push	eax
	sub	eax,ecx				;EAX=remaining block size
	cmp	eax,32				;Is it smaller than 16
	pop	eax
	jbe	short @@Destroy_block		;Yds: Destroy last block
	mov	ds:[ebx+8],ecx
	lea	edx,[ebx+ecx+16]		;EDX points to new header
	mov	dword ptr ds:[edx],BLOCK_MAGIC
	pop	dword ptr ds:[edx+4]		;Restore flags
	sub	eax,ecx                         ;EAX=remaining size after block
	sub	eax,16				;Subtract new header
	mov	ds:[edx+8],eax			;Save size !
	jmp	@@End


	;
	;In this case we can destroy the following block, because it
	;would get too small to exist.
	;
@@Destroy_Block:
	mov 	ds:[ebx+8],eax			;Set total size
	mov	dword ptr ds:[ebx],BLOCK_MAGIC
	pop	dword ptr ds:[ebx+4]
	and	dword ptr ds:[ebx+4],NOT FREE_BLOCK
	jmp	@@End

	;
	;Here we allocate a brand new block and copy all...
	;
@@Alloc_NEw_Block:
	push    ebx				;Save original block address
	call	Malloc			;Alloc new block !
	pop	ebx				;Restore original block address
	jc	short @@No

	cld
	push	edi
	push	esi
	push	eax				;Save new address
	lea	esi,[ebx+16]
	mov	edi,eax
	mov	ecx,ds:[ebx+8]			;Get old size !
	shr	ecx,2
	rep 	movsd				;Copy block !

	lea     ecx,[ebx+16]			;ECX: Old memory handle
	call	Free

	pop	eax				;Restore new handle
	pop	esi
	pop	edi
	pop	es
	pop	ds
	retn


@@End:  lea	eax,[ebx+16]			;Return value
	clc
	pop	es
	pop	ds
	retn

@@No:	xor	eax,eax
	stc
	pop	es
	pop	ds
	retn

@@Err:	mov	esi,OFFSET XTXT21
	jmp	Main_Exception_Handler
Realloc ENDP


;
;  USER CALLABLE FUNCTIONS		              DOS-MEMORY-MANAGEMENT
;
;
;
; Now come four routines for low-memory allocations. They use the DOS-
; function 48h:
;      void far *Malloc    (size_l );
;      int       Free      (void far *);
;      size_l    Coreleft  (void);
;      void far *DMA_Malloc(size_t);
; You should use these functions instead of any other allocation routine.
; Note that they return the old SEG:OFF pointers and NOT linear addresses !
; But you can smply convert them to a linear address:
; (DX holds segment, AX offset):
; and edx,0ffffh
; and eax,0ffffh
; shl edx,4
; add eax,edx          ;Now the linear address is in EAX
;
;
;In:
;  EBX	- Len (in Bytes)
;Out:
;  EAX	- DATA32 address
;
DOS_Malloc PROC NEAR
	push	ds
	mov	ds,cs:[DATA32_Selector]

	cmp 	ebx,0fffe0h	  	;About 1 MB ????
	jae 	short @@Err
	add	ebx,15
	shr 	ebx,4                   ;Paragraphs
	mov	ds:[v86_BX],BX
	mov	ds:[v86_AX],4800h
	mov	eax,21h
	call	Invoke_Real_Int

	xor	eax,eax			;Clear return value
	push	dword ptr ds:[v86_EFLAGS]
	popfd
	jc	short @@Err
	movzx	eax,ds:[v86_AX]
	shl 	eax,4
	sub	eax,ds:[DATA32_Address]
	clc
@@Err:	pop	ds
	retn
DOS_Malloc ENDP




;
;In:
;  EAX	- DATA32 Address of memory block
;Out:
;  CF   - Set => Error
;
DOS_Free PROC NEAR
	push	ds
	mov	ds,cs:[DATA32_Selector]

	add	eax,ds:[DATA32_Address]
	shr	eax,12			;Convert to segment
	mov	ds:[v86_ES],ax
	mov	ds:[v86_AX],4900h
	mov	eax,21h
	call	Invoke_Real_Int

	push	dword ptr ds:[v86_EFLAGS]
	popfd
	retn
DOS_Free ENDP




;
;In:
;  Nothing
;Out:
;  EAX	- Largest free block available
;
DOS_Coreleft PROC NEAR
	push	ds
	mov	ds,cs:[DATA32_Selector]

	mov	ds:[v86_BX],0ffffh
	mov	ds:[v86_AX],4800h
	mov	eax,21h
	call	Invoke_Real_Int
	movzx 	eax,ds:[v86_BX]
	shl 	eax,4
	push	dword ptr ds:[v86_EFLAGS]
	popfd

	pop	ds
	retn
DOS_Coreleft ENDP



;
;In:
;  EAX  - DATA32-address of memy block
;  ECX  - New requested size in bytes
;Out:
;  EAX  - Memory handle or zero
;
DOS_Realloc PROC NEAR
	push	ds
	push	eax
	mov	ds,cs:[DATA32_Selector]

	add	eax,ds:[DATA32_Address]
	cmp 	ecx,0fffe0h	  	;About 1 MB ????
	jae 	short @@Err
	add	ecx,15
	shr 	ecx,4                   ;Paragraphs
	shr	eax,4
	mov	ds:[v86_BX],BX
	mov 	ds:[v86_ES],ax
	mov	ds:[v86_AX],4a00h
	mov	eax,21h
	call	Invoke_Real_Int

	pop	eax			;Restore old memory handle
	push	dword ptr ds:[v86_EFLAGS]
	popfd
	jnc	short @@Succ
@@Err:	xor	eax,eax			;Carry => Error !
	stc
@@Succ:	pop	ds
	retn
DOS_Realloc ENDP



;
;In:
;  ECX	- Len (max 64kB)
;Out:
;  EAX	- DATA32 address of memory block
;
DOS_DMA_Malloc PROC NEAR
	push	ds
	mov	ds,cs:[DATA32_Selector]

	mov 	ebx,ecx
	shr 	ebx,4
	inc     ebx                     ;EBX holds size in paragraphs
	push 	ebx           		;Save requested size...
	mov	ds:[v86_EBX],ebx
	mov	ds:[v86_AX],4800h
	mov	eax,21h
	call	Invoke_Real_Int
	pop	ebx			;Restore requested size
	push	dword ptr ds:[v86_EFLAGS]
	popfd				;Error ?
	jc 	@@Err
	movzx 	eax,ds:[v86_AX]       	;AX contains memory segment
	mov	ecx,eax
	mov 	edx,eax
	add 	ecx,ebx
	shr 	ecx,12                  ;End segment in CX
	shr 	edx,12                  ;Start segment in DX
	cmp 	ecx,edx
	je 	short @@Succ           	;Equal => Success !

	push	ebx       		;Save requested size !
	push 	eax                     ;Save old segment address
	mov	ds:[v86_ES],ax
	mov	ds:[v86_AX],4900h       ;Free this block again...
	mov	eax,21h
	call	Invoke_Real_Int
	pop 	eax            		;Restore old segment address...

	mov 	ebx,0ffffh
	sub 	ebx,eax
	and 	ebx,00fffh              ;Paragraphs to next segment
	mov	ds:[v86_EBX],ebx
	mov	ds:[v86_AX],4800h
	mov	eax,21h        		;Allocate new memory...
	call	Invoke_Real_Int
	pop	ecx			;Get requested size again in ECX
	push	dword ptr ds:[v86_EFLAGS]
	popfd
	jc	@@Err			;Carry ==> Error

	push	ds:[v86_ax]		;Save allocated address
	call 	DOS_DMA_Malloc   	;Try again
	pop	ds:[v86_es]		;Restore allocated address
	mov	ds:[v86_ax],4900h	;Free old block
	push 	eax			;Save result...
	mov	eax,21h        		;Do DOS_Free !
	call	Invoke_Real_Int
	pop 	eax			;Restore new block
	shr	eax,4			;Shift it
@@Succ: sub	eax,ds:[DATA32_Address]
	shl 	eax,4			;Success !
	clc
	pop	ds
	retn

@@Err:	xor 	eax,eax			;DOS-Error !
	stc
	pop	ds
	retn
DOS_DMA_Malloc ENDP



;
;   HIGH-END USER CALLABLE FUNCTIONS		             VIRTUAL MEMORY
;
;
;
; The following two routines are used to map physical memory into/out of
; linear address s#pace. Useful for graphic-adapters that have a linear
; frame buffer.
;
;
; Map_Memory:
;   Maps in a chunk of memory
;   Input:
;	EAX	- PHYSICAL address of memory to map in
;	ECX	- Number of 4kb pages to map in
;   Output:
;	EAX	- Linear address of mapped memory
;    	[CF]	- Error flag
;
; Unmap_Memory:
;   Maps out a chunk of memory
;   Input:
;	EAX	- LINEAR address of memory to map out
;	ECX	- Number of 4kb pages to map out
;   Output:
;    	[CF]	- Error flag
;
Map_Memory:
	push	ds
	push	esi
	push	ebp
	test	ds:[GOMEZ_System],PAGING_ENABLED
	jz	short @@Succ
	test	ecx,ecx			;Zero pages ???
	jz	short @@Succ
	;
	mov	esi,ds:[Page_Directory]
	sub	esi,ds:[DATA32_Address]
	xor	edx,edx			;EDX = Number of continuious pages
	mov	ebp,esi			;EBP = ptr to first table
@@L1:   cmp	dword ptr ds:[esi],0
	je	short @@Err
	add	ebp,1000h		;Advance one table

	xor	ebx,ebx			;EBX = index in table
@@L2:	cmp	edx,ecx			;Are there enough free pages ???
	jae	short @@Map
	inc	edx			;Increment free page counter
	cmp	dword ptr ds:[ebp+4*ebx],0
	je	@@J3
	xor	edx,edx			;Clear free page counter
@@J3:	inc	ebx                     ;Increment table index
	cmp	ebx,1024
	jb	short @@L2              ;Read next table if nesesecary
	add	esi,4			;ESI = next index in directory
	jmp	short @@L1
	;
@@map:  lea	esi,[ebp+4*ebx+4]	;ESI = ptr to first unused entry
	neg	edx			;EDX = negative table counter
	lea	ebx,[esi+4*edx]		;EBX = first used page
	or	ax,407h			;Set present bit and bit 10 (available)
@@L3:	mov	ds:[esi+4*edx],eax
	add	eax,1000h
	inc	edx
	jnz	short @@L3
	;
	mov	eax,ebx
	add	eax,ds:[DATA32_Address]
	sub	eax,ds:[Page_Directory]
	shl	eax,10			;EAX = linear address
@@Succ:	clc
	pop	ebp
	pop	esi
	pop	ds
	retn
	;
@@Err:	stc
	pop	ebp
	pop	esi
	pop	ds
	retn
;
Unmap_Memory:
	stc
	retn



;
;  USER CALLABLE FUNCTIONS		                    FILE-ROUTINES
;
;
;
; Now follow some I/O routines for disk-access in FLAT-Mode
; Basically they use normal DOS-interrupts and copy chunks from base memory
; o XMS. The size of these chunks is determined by IO_BUFFER_SIZE.
;
; These functions only work in the binary file mode, but are compatible with
; the equivalents in Borland C++, which use DOS-calls. The syntax is just
; the same like _open,_read,_write etc. You can even use the read and
; write commands together with handles opened by Broland C++ 3.1 _open !!!
;
O_RDONLY                equ     1
O_WRONLY                equ     2
O_RDWR                  equ     4



;
;In:
;  CX 	- Mode
;  EBX  - DATA32 ptr to file name
;Out:
;  EAX 	- Handle
;  CF	- Error flag
;
Open PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ecx			;Save mode
	cld
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]

	mov	ecx,128/4
	mov	esi,ebx
	mov	edi,OFFSET DOS_ASCII_Buffer
	rep	movsd

	pop	ecx			;Restore mode
	mov	ebx,ecx			;EBX=ECX=mode
	mov	ax,3d01h
	test 	cx,O_WRONLY
	jnz 	short @@1
	mov 	al,2
	test 	cx,O_RDWR
	jnz 	short @@1
	xor 	al,al
@@1:    mov 	cl,0f0h
	and 	cl,bl
	or 	al,cl
	mov	ds:[v86_DS],SEG CODE32
	mov	ds:[v86_EAX],eax
	mov	ds:[v86_EDX],OFFSET DOS_ASCII_Buffer
	mov	eax,21h
	call	Invoke_Real_Int
	mov	eax,ds:[v86_EAX]	;Get handle
	push	dword ptr ds:[v86_EFLAGS]
	popfd
	jnc 	short @@Succ
	xor	eax,eax			;Set handle to zero for error
	stc

@@Succ:	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
Open ENDP





;
;In:
;  CX	- Attributes (usually 0)
;  EBX	- DATA32 ptr to file-name
;Out:
;  EAX	- Handle
;  CF	- Error flag
;
Creat PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]

	cld
	mov 	ds:[v86_ECX],ecx
	mov	ds:[v86_AH],03ch
	mov	ds:[v86_DS],SEG CODE32
	mov	ds:[v86_EDX],OFFSET DOS_ASCII_Buffer

	mov	ecx,128/4
	mov	esi,ebx
	mov	edi,OFFSET DOS_ASCII_Buffer
	rep	movsd

	mov	eax,21h
	call	Invoke_Real_Int

	xor	eax,eax			;Clear for error result
	push	dword ptr ds:[v86_EFLAGS]
	popfd
	jc 	short @@Err
	mov	eax,ds:[v86_EAX]
@@Err:	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
Creat ENDP





;
;In:
;  EBX	- Handle
;Out:
;  CF   - Error-flag
;
Close PROC NEAR
	push	ds
	mov	ds,cs:[DATA32_Selector]
	mov 	ds:[v86_ah],3eh
	mov 	ds:[v86_EBX],ebx

	mov	eax,21h
	call	Invoke_Real_Int
	push	dword ptr ds:[v86_eflags]
	popfd

	pop	ds
	retn
Close ENDP






;
;In:
;  EBX	- Handle
;  ECX  - Position
;  AL  	- Mode
;Out:
;  EAX	- New position
;
Seek PROC NEAR
	push	ds
	mov	ds,cs:[DATA32_Selector]

	mov 	ah,42h
	mov	ds:[v86_EAX],eax
	mov 	ds:[v86_EBX],ebx
	mov 	ds:[v86_EDX],ecx
	shr	ecx,16
	mov 	ds:[v86_ECX],ecx

	mov	eax,21h
	call	Invoke_Real_Int

	mov 	eax,ds:[v86_edx]
	shl	eax,16
	mov	ax,ds:[v86_ax]
	push	dword ptr ds:[v86_eflags]
	popfd

	pop	ds
	retn
Seek ENDP






;
;In:
;  EBX	- Handle
;Out:
;  EAX	- Position
;
Tell PROC NEAR
	push	ds
	mov	ds,cs:[DATA32_Selector]

	mov	ds:[v86_AX],4201h
	mov 	ds:[v86_BX],bx
	mov 	ds:[v86_dx],0
	mov 	ds:[v86_cx],0

	mov	eax,21h
	call	Invoke_Real_Int

	mov 	eax,ds:[v86_edx]
	shl	eax,16
	mov	ax,ds:[v86_ax]
	push	dword ptr ds:[v86_eflags]
	popfd

	pop	ds
	retn
Tell ENDP







;
;In:
;  EBX	- Handle
;  EDX	- DATA32 ptr to dest
;  ECX	- Len (Bytes)
;Out:
;  EAX  - Bytes read
;  CF	- Error flag
;
Read PROC NEAR
	push	ds
	push	es
	push 	ebp
	push 	esi
	push 	edi
	mov	ds,cs:[DATA32_Selector]
	mov 	es,ds:[DATA32_Selector] ;ES is used for linear memory

	cld
	mov	edi,edx
	mov	esi,ecx
	xor 	ebp,ebp             	;EBP holds bytes read
   @@Loop:
	test 	esi,esi
	jz 	@@Succ

	mov 	ecx,esi                	;CX holds lower word of size
	cmp 	esi,IO_Buffer_Size*1024	;Is ESI bigger than buffer ?
	jb 	short @@1               ;JB => No,leave SI in cx
	mov 	ecx,IO_Buffer_Size*1024
   @@1: push 	ebx                     ;Save handle
	push 	ecx
	push	esi
	push	edi
	push	ebp
	mov	eax,ds:[IO_Buffer]
	shr	eax,4
	mov     ds:[v86_EBX],ebx	;File_Handle
	mov     ds:[v86_ECX],ecx	;Read_Size
	mov	ds:[v86_AH],3fh		;Read block
	mov	ds:[v86_DS],ax		;Destination in DS:DX
	mov	ds:[v86_EDX],0

	mov	eax,21h
	call	Invoke_Real_Int

	pop	ebp
	pop	edi
	pop	esi
	pop 	edx			;EDX: Bytes to read
	pop 	ebx                     ;Restore handle

	movzx 	ecx,ds:[v86_AX]       	;ECX will be used as a counter
	sub 	esi,ecx                 ;Subtract bytes_read from bytes_to_read
	add 	ebp,ecx                 ;Add bytes_read to

	push 	esi
	cld				;Increment ptrs !
	mov 	esi,ds:[IO_Buffer]      ;ES:ESI points to Buffer
	sub	esi,ds:[DATA32_Address]
	rep 	movs byte ptr es:[edi],es:[esi]
	pop 	esi

	push	dword ptr ds:[v86_EFLAGS]
	popfd                          	;Restore carry-bit
	jc short @@Err
	cmp 	dx,ds:[v86_AX]		;IS bytes read= bytes to read ???
	je 	@@Loop

@@Succ:	clc
@@Err:	mov 	eax,ebp
	pop 	edi
	pop 	esi
	pop 	ebp
	pop	es
	pop	ds
	retn
Read ENDP





;
;In:
;  EBX	- Handle
;  EDX	- DATA32 ptr to src
;  ECX	- Len (Bytes)
;Out:
;  EAX  - Bytes written
;  CF   - Error flag
;
Write PROC NEAR
	push	ds
	push	es
	push 	ebp
	push 	esi
	push 	edi
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]

	cld
	mov	esi,edx			;ESI = source ptr
	mov	edi,ecx			;EDI = source size
	xor 	ebp,ebp             	;EBP holds bytes written
   @@Loop:
	test 	edi,edi
	jz 	@@Succ

	mov 	ecx,edi                	;ECX holds size
	cmp 	ecx,IO_Buffer_Size*1024	;Is ECX bigger than buffer ?
	jb 	short @@1               ;JB => No,leave SI in cx
	mov 	ecx,IO_Buffer_Size*1024
   @@1: push 	ebx                     ;Save handle
	push 	ecx			;Save bytes to write this time
	push	edi			;Save total bytes to write
	push	ebp			;Save bytes written
	mov	eax,ds:[IO_Buffer]
	shr	eax,4
	mov     ds:[v86_EBX],ebx	;File_Handle
	mov     ds:[v86_ECX],ecx	;Write_Size
	mov	ds:[v86_AH],40h		;Write block
	mov	ds:[v86_DS],ax		;Source in DS:DX
	mov	ds:[v86_EDX],0

	cld				;Increment ptrs !
	mov 	edi,ds:[IO_Buffer]      ;ES:ESI points to Buffer
	sub	edi,ds:[DATA32_Address]
	rep 	movs byte ptr es:[edi],es:[esi]
	push	esi			;Save source ptr

	mov	eax,21h			;Do INT !
	call	Invoke_Real_Int

	pop	esi
	pop	ebp
	pop	edi
	pop 	edx			;EDX:Bytes to read
	pop 	ebx                     ;Restore handle

	movzx 	ecx,ds:[v86_AX]       	;ECX will be used as a counter
	sub 	edi,ecx                 ;Subtract bytes_read from bytes_to_read
	add 	ebp,ecx                 ;Add bytes_read to

	push	dword ptr ds:[v86_EFLAGS]
	popfd                           ;Restore carry-bit
	jc short @@Succ
	cmp 	dx,ds:[v86_AX]		;IS bytes written= bytes to write ???
	je 	@@Loop


@@Succ:	clc
@@Err:	mov 	eax,ebp
	pop 	edi
	pop 	esi
	pop 	ebp
	pop	es
	pop	ds
	retn
Write ENDP



;
;In:
;  EBX	- Handle
;  ECX	- Requested size
;Out:
;  CF 	- Error-flag
;
Chsize PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]

	push	ecx			;Save requested size
	mov     ds:[v86_eax],4201h     	;Seek to current position
	mov     ds:[v86_ebx],ebx
	mov	ds:[v86_ecx],0
	mov	ds:[v86_edx],0
	mov	eax,21h
	call	Invoke_Real_Int
	push	dword ptr ds:[v86_EFLAGS]
	popfd                           ;Restore carry-bit
	jc      @@Err
	pop	ecx			;We need to swap some stack-variables...
	push	ds:[v86_ax]
	push	ds:[v86_dx]		;Save current position...
	push	ecx

	mov     ds:[v86_eax], 4202h	;Seek to end of file
	mov     ds:[v86_ecx], 0
	mov     ds:[v86_edx], 0
	mov	eax,21h
	call	Invoke_Real_Int

	pop	ebx			;Restore requested size
	mov	eax,ds:[v86_edx]
	shl	eax,16
	mov	ax,ds:[v86_ax]		;EAX contains size of file

	push	dword ptr ds:[v86_EFLAGS]
	popfd                           ;Restore carry-bit
	jc      @@Err
	cmp	eax,ebx
	ja      chsizeTruncate


	;
	;Here we expand the file
	;
chsizePad:
	cld
	mov	edi,ds:[IO_Buffer]
	sub	edi,ds:[DATA32_Address]
	mov     ecx,IO_Buffer_Size*1024/4
	xor	eax,eax
	rep  	stosd			;Clear write buffer

	mov 	edi,ebx          	;EDI holds len
	sub     edi,eax                 ;EDI holds total bytes to write
chsizeWriteLoop:
	mov	ecx,IO_Buffer_Size*1024
	cmp	edi,ecx
	jae	short @@1		;A full buffer ???
	mov	ecx,edi
@@1:    mov	eax,ds:[IO_Buffer]
	shr	eax,4
	mov	ds:[v86_DS],ax
	mov	ds:[v86_DX],0
	mov 	ds:[v86_ah],40h        	;Write block
	mov	eax,21h
	call	Invoke_Real_Int
	push	dword ptr ds:[v86_EFLAGS]
	popfd                           ;Restore carry-bit
	jc	@@Err
	movzx 	ecx,ds:[v86_ax]         ;ECX will be used as a counter
	sub 	edi,ecx                 ;Subtract bytes_read from bytes_to_read
	jnz 	short chsizeWriteLoop
	jmp	chsizeSeekBack


	;
	;Here we truncate the file
	;
chsizeTruncate:
	mov     ds:[v86_eax],4200h      ;seek to new end-of-file
	mov     ds:[v86_edx],ebx
	rol	ebx,16
	mov     ds:[v86_ecx],ebx
	mov	eax,21h
	call	Invoke_Real_Int
	push	dword ptr ds:[v86_EFLAGS]
	popfd                           ;Restore carry-bit
	jc      @@Err

	mov     ds:[v86_ah], 40h      	;truncate at desired position
	mov	ds:[v86_cx],0
	mov	eax,21h
	call	Invoke_Real_Int
	push	dword ptr ds:[v86_EFLAGS]
	popfd                           ;Restore carry-bit
	jc      @@Err

chsizeSeekback:
	pop	eax			;Get original pos
	mov     ds:[v86_edx],eax
	rol	eax,16
	mov     ds:[v86_ecx],eax
	mov	ds:[v86_eax],4200h
	mov	eax,21h
	call	Invoke_Real_Int

	clc
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn

@@Err:  stc
	pop	eax			;Throw away original pos
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
Chsize ENDP




;
;Getchar:
; Input:
;       EBX	- file-handle
; Output:
;	EAX	- next character in file
;	CF	- error flag
;
Getchar PROC NEAR
	push	ds
	mov	ds,cs:[DATA32_Selector]

	mov     ds:[v86_EBX],ebx	;File_Handle
	mov     ds:[v86_ECX],1		;Read_Size
	mov	ds:[v86_AH],3fh		;Read block
	mov	ds:[v86_DS],SEG CODE32	;Destination in DS:DX
	mov	ds:[v86_EDX],OFFSET DOS_ASCII_Buffer

	mov	eax,21h
	call	Invoke_Real_Int

	movzx	eax,byte ptr ds:[DOS_ASCII_Buffer]
	push	dword ptr ds:[v86_eflags]
	popfd

	pop	ds
	retn
Getchar ENDP



;
;Putchar:
; Input:
;	EAX	- byte to write
;       EBX	- file-handle
; Output:
;	CF 	- Error-flag
;
Putchar PROC NEAR
	push	ds
	mov	ds,cs:[DATA32_Selector]

	mov	ds:[DOS_ASCII_Buffer],al

	mov     ds:[v86_EBX],ebx	;File_Handle
	mov     ds:[v86_ECX],1		;Write_Size
	mov	ds:[v86_AH],40h		;Write block
	mov	ds:[v86_DS],SEG CODE32	;Source in DS:DX
	mov	ds:[v86_EDX],OFFSET DOS_ASCII_Buffer

	mov	eax,21h
	call	Invoke_Real_Int
	push	dword ptr ds:[v86_eflags]
	popfd

	pop	ds
	retn
Putchar ENDP


;
;  USER CALLABLE FUNCTIONS		                DIRECTORY-ROUTINES
;
;
;
; And now some directory functions (get first, get next etc...)
;
; FindFile:
;  Input:
;   	AL 	- type of search: 4E-first, 4F-next (FINDFIRST, FINDNEXT)
;   	EBX 	- DATA32 ptr to search mask
;   	ECX 	- search attributes
;   	EDX 	- DATA32 ptr to 13 byte buffer for filename found
;  Output:
;   	ECX	- Attribute of file
;      CF=1 	- file not found
;        [EDX] - ?
;      CF=0 	- file found
;        [EDX] - filename
;  Destroys:
;	EAX,EBX,ECX,EDX
;
;
;
; Chdir:
;  Input:
;   	EBX 	- DATA32 ptr to new directory
;  Output:
;   	CF	- error flag
;
FindFile PROC NEAR
	push	ds
	push	es
	push 	esi
	push 	edi
	push	ebp
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]

	shl	eax,8
	push	edx
	push	ecx
	push	eax
	;
	mov 	esi,ebx			;ES:ESI points to file mask
	mov	edi,OFFSET DOS_ASCII_Buffer
	mov	ecx,128/4
	rep	movsd
	;
	mov	ds:[v86_ah],2fh
	mov	eax,21h
	call	Invoke_Real_Int		;Get current DTA

	mov	bp,ds:[v86_es]
	shl	ebp,16
	mov	bp,ds:[v86_bx]		;EBP = SEG:OFF DTA address
	;
	mov	eax,ds:[IO_Buffer]
	shr	eax,4
	mov	ds:[v86_ds],ax
	mov	ds:[v86_dx],0
	mov	ds:[v86_ah],1ah
	mov	eax,21h
	call	Invoke_Real_Int		;Set new DTA
	;
	pop	ds:[v86_eax]
	pop	ds:[v86_ecx]		;Save attribute to search
	pop	edi			;ES:EDI points to dst

	mov 	ds:[v86_ds],SEG CODE32
	mov 	ds:[v86_edx],OFFSET DOS_ASCII_Buffer
	mov 	eax,21h
	call	Invoke_Real_Int         ;Do seacrh
	push	dword ptr ds:[v86_EFLAGS]
	;
	mov	ds:[v86_dx],bp
	shr	ebp,16
	mov	ds:[v86_ds],bp
	mov	ds:[v86_ah],1ah
	mov	eax,21h
	call	Invoke_Real_Int		;Set old DTA
	;
	mov 	esi,ds:[IO_Buffer]
	sub	esi,ds:[DATA32_Address]
	add	esi,1eh
	movzx 	ecx,byte ptr ds:[esi+15h-1eh]
	movsd
	movsd
	movsd
	movsb
	popfd				;Get carry bit
	pop	ebp
	pop 	edi
	pop 	esi
	pop	es
	pop	ds
	retn
FindFile ENDP




Chdir PROC NEAR
	push	ds
	push	es
	push 	esi
	push 	edi
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]

	mov 	esi,ebx			;ES:ESI points to new directory
	mov	edi,OFFSET DOS_ASCII_Buffer
	mov	ecx,128/4
	rep	movsd

	mov 	ds:[v86_ds],SEG CODE32
	mov 	ds:[v86_edx],OFFSET DOS_ASCII_Buffer
	mov 	ds:[v86_ah],3bh
	mov 	eax,21h
	call	Invoke_Real_Int         ;Change directory !
	push	dword ptr ds:[v86_EFLAGS]
	popfd				;Get carry bit
	pop 	edi
	pop 	esi
	pop	es
	pop	ds
	retn
Chdir ENDP




;
;   HIGH-END USER CALLABLE FUNCTIONS		       ENVIRONMENT FUNCTIONS
;
;
;
; Now come some command-line and environment-stuff thingys
;
;
; Scan_Argument:
;    Looks for a specific string on the command-line. The "~"-Joker is
;    supported in the input string for any number of characters. If you
;    only supply a "~", then the first argument will be returned.
;    Input:
;	EAX	- DATA32 ptr to switch-string
;    Output:
;	EAX	- DATA32 ptr to switch or zero
;	CF	- Error flag
;
; Scan_Environment:
;    Looks for a specific string in the environment. The "~"-Joker is
;    supported in the input string for any number of characters
;    Input:
;	EAX	- DATA32 ptr to switch-string
;    Output:
;	EAX	- DATA32 ptr to switch or zero
;	CF	- Error flag
;
Scan_Argument:
	push	ds
	push	esi
	push	edi
	mov	ds,cs:[DATA32_Selector]

	mov     esi,ds:[PSP_Address]
	mov	edi,eax				;EDI = source-string
	sub	esi,ds:[DATA32_Address]
	movzx	edx,byte ptr ds:[esi+80h]	;EDX = command line size
	add     esi,81h		      		;DS:ESI = Command Line address
	test	edx,edx
	jz	@@Nothing
	;
@@L1:   cmp	byte ptr ds:[esi],0		;Skip leading zeros
	jne	short @@cmp
		inc	esi			;Skip this zero
		dec	edx
		jnz	short @@L1		;Repeat test, if not reached
		jmp	short @@Nothing		;  the end of the command line
@@cmp:	call	compare_entry
	jnc	short @@success
	@@L2:	mov	al,ds:[esi]		;AL=character
		inc	esi			;Skip char
		dec	edx
		jz	short @@Nothing
		test	al,al			;Skip to next entry
		jz	short @@L1
		jmp	short @@L2
	;
@@success:
	mov	eax,esi
	pop	edi
	pop	esi
	pop	ds
	retn
	;
@@Nothing:
	xor	eax,eax
	stc
	pop	edi
	pop	esi
	pop	ds
	retn
;
Scan_Environment:
	push	ds
	push	esi
	push	edi

	mov	ds,cs:[DATA32_Selector]
	mov	edi,eax				;DS:EDI = ptr to source
	mov 	eax,ds:[PSP_Address]
	sub	eax,ds:[DATA32_Address]
	movzx   esi,word ptr ds:[eax+2Ch]      	;
	shl	esi,4				;DS:ESI points to envirnoment
	sub	esi,ds:[DATA32_Address]
	mov	edx,7fffh			;EDX = size of environment
	;
@@L1:   call	compare_entry			;Compare them
	jnc	short @@success
	xor	al,al
	@@L2:	cmp	ds:[esi],al
		je	short @@zero
		inc	esi
		dec	edx
		jnz	short @@L2
	jmp   	@@nothing	             	;exit if not found
@@Zero: inc	esi
	dec	edx				;EDX = remaining size
	cmp     byte ptr ds:[esi],al    	;second null in a row?
	jne     @@L1		               	;if not, try again
	;
@@nothing:
	stc
	pop	edi
	pop	esi
	pop	ds
	retn

@@success:
	mov	eax,esi
	pop	edi
	pop	esi
	pop	ds
	retn
;
compare_entry:
	xor	ecx,ecx			;ECX = char. counter
	;
@@L1:   mov	al,ds:[edi+ecx]         ;AL = byte of compare string
	mov	bl,ds:[esi+ecx]		;BL = byte of command line
	cmp	al,'~'			;Is it a tilde in compare string ?
	je	short @@succ		;JE => Success !
	ifndef SCAN_CASE_SENSITIV
	 cmp	bl,'a'
	 jb	short @@1
	 cmp	bl,'z'
	 ja	short @@1
	 and	bl,NOT 20h		;Make uppercase
	endif
@@1:	cmp	al,bl			;AL = BL ?
	jne	short @@nosuccess	;JNE => No success
	test	al,al			;AL = 0  (End of compare)
	jz	short @@succ		;JE => success !
	inc	ecx			;Goto next byte
	cmp	ecx,edx
	jbe	short @@L1
	;
@@nosuccess:
	stc
	retn
	;
@@succ: clc
	retn
;
code32 ends
;
;
;
;   STACK SEGMENT
;
;
;
codeend segment para stack use32 'stack'
	ORG 0
	db 16 dup ("STACK",0)
codeend ends
END boot16