;͸
;                                                                          
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                    
;                                                                          
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	    
; You may use the whole code or only parts of it in your own programs      
; whether they are commercial or not. BUT you must give credits for these  
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                       
; I am not responsible for any damage or loss caused by this program, so   
; if you success in erasing your harddisk with this code, then it is your  
; own fault and you should not claim me to be responsible...               
; I would be very pleased if you also sent me a postcard or even a letter  
; if you can use this code. My address:                                    
;                                                                          
;        Kaya Memisoglu                                                    
;        Reichenberger Ring 50                                             
;        63512 Hainburg                                                    
;        Germany                                                           
;	                                                                    
;	  Internet: memisogl@stud.uni-frankfurt.de                          
;                                                                          
; You can also leave a message for Marc van Shaney on the Nirvana BBS:     
;                                                                          
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza      
;                                                                          
;                                                                          
;;
;
;This program will make GOMEZ-programs run under PMODE.
;
.386p
locals

STACKLEN        = 40h                   ; size of stack in paragraphs

PMODE_TEXT      segment para public use16 'CODE'
PMODE_TEXT      ends
CODE16          segment para public use16 'CODE'
CODE16          ends
CODE32		segment para public use32 'CODE'
CODE32		ends
EXE_STACK       segment para stack use16 'STACK'
EXE_STACK       ends

extrn   	_pm_info:far, _pm_init:far

CODE16          segment para public use16 'CODE'
assume  	cs:CODE16, ds:CODE16
org     	0

;
errmsgtbl       dw      errmsg0,errmsg1,errmsg2,errmsg3
		dw      errmsg4,errmsg5,errmsg6

errmsg0         db      'Not enough low memory!',13,10,36
errmsg1         db      '80386 or better not detected!',13,10,36
errmsg2         db      'System already in protected mode and no VCPI or DPMI found!',13,10,36
errmsg3         db      'DPMI host is not 32bit!',13,10,36
errmsg4         db      'Could not enable A20 gate!',13,10,36
errmsg5         db      'Could not enter DPMI 32bit protected mode!',13,10,36
errmsg6         db      'Could not allocate needed DPMI selectors!',13,10,36



;
start:                                  ; execution starts here
	push 	cs                      ; DS = CS
	pop 	ds

	call 	_pm_info                ; get information
	jnc 	short @@startf0         ; if no error, go on

@@startf1:
	mov 	si,ax			; print error message for code AX
	add 	si,ax
	mov 	dx,errmsgtbl[si]
	mov 	ah,9
	int 	21h
	mov 	ax,4cffh
	int 	21h

@@startf0:
	xor 	ax,ax			; check low memory and allocate low
	mov 	cx,ss			;  buffer needed for protected mode
	add 	cx,STACKLEN
	mov 	dx,es:[2]
	sub 	dx,cx
	cmp 	dx,bx
	jb 	@@startf1
	mov 	es,cx

	call 	_pm_init		; enter protected mode
	jc 	@@startf1		; if error, go to error message
;
	mov	ax,3			; get selector increment value
	int	31h
	mov 	si,ax			; SI = increment value

	xor	ax,ax			; allocate selectors
	mov	cx,3			; number of descriptors
	int	31h
	mov	di,ax			; DI = base selector

	mov	bx,di			; BX = selector
	mov	ax,7			; Set base address
	xor	cx,cx
	mov	dx,SEG CODE32
	shld	cx,dx,4
	shl	dx,4			; CX:DX = CODE32 address
	int	31h
	mov	ax,8			; Set segment limit
	mov	bx,di			; BX = selector
	mov	cx,00fffh
	mov	dx,0ffffh		; CX:DX = 256MB limit
	int	31h

	mov	fs,di			; FS = selector for DATA32
	mov	fs:[DATA32_Selector],di
	mov	eax,SEG CODE32
	shl	eax,4
	mov	fs:[DATA32_Address],eax	; Save address
	mov	eax,SEG CODE16
	shl	eax,4
	mov	fs:[DATA16_Address],eax	; Save address
	mov	fs:[DATA16_Selector],ds
	mov	fs:[CODE16_Selector],cs
	mov	fs:[STACK32_Selector],ss

	add	di,si			; DI points to next descriptor
	mov	fs:[LIN_Selector],di
	mov	bx,di			; BX = selector
	mov	ax,7			; Set base address
	xor	cx,cx
	xor	dx,dx			; CX:DX = 0
	int	31h
	mov	ax,8			; Set segment limit
	mov	bx,di			; BX = selector
	mov	cx,0ffffh
	mov	dx,0ffffh		; CX:DX = 4GB limit
	int	31h

	add	di,si			; DI points to next descriptor
	mov	fs:[CODE32_Selector],di
	mov	bx,di			; BX = selector
	mov	ax,7			; Set base address
	xor	cx,cx
	mov	dx,SEG CODE32
	shld	cx,dx,4
	shl	dx,4			; CX:DX = CODE32 address
	int	31h
	mov	ax,8			; Set segment limit
	mov	bx,di			; BX = selector
	mov	cx,0ffffh
	mov	dx,0ffffh		; CX:DX = 4GB limit
	int	31h
	mov	ax,9			; Set access rights
	mov	bx,di
	mov	cx,1100000010011010b	; Code/Granular/Readable/etc...
	int	31h

	mov	ax,6                    ; get segment base
	mov	bx,ss			; stack segment
	int	31h
	mov	word ptr fs:[STACK32_Address],dx
	mov	word ptr fs:[STACK32_Address+2],cx

	mov	ax,6                    ; get segment base
	mov	bx,es			; PSP segment
	int	31h
	shl  	ecx,16
	mov 	cx,dx
	sub	ecx,fs:[DATA32_Address]
	mov	fs:[PSP_Address],ecx
;







	push 	ds                      ; ES = DS for register structure
	pop 	es

	mov edi,offset V86_edi     	; offset of register structure
	xor cx,cx                       ; no parameters on stack
	mov bx,21h                      ; call interrupt 21h
	mov ax,300h                     ; INT 31h function 0300h

	mov V86_ah,9               	; function code 9, put string
	mov V86_ds,CODE16           	; set DS:DX for DOS string put
	mov V86_dx,offset msg0
	mov V86_ss,0               	; SS:SP = 0, PMODE will provide stack
	mov V86_sp,0

	int 31h                         ; do the call to real mode


	xor ah,ah                       ; wait for keypress
	int 16h


	push ss                         ; ES = SS for register structure
        pop es

	sub esp,32                      ; stack space for register structure
        mov edi,esp                     ; EDI = offset of register structure

	push cs                         ; DS:ESI = callback routine
	pop ds
        mov esi,offset callback

        mov ax,303h                     ; INT 31h function 0303h
        int 31h                         ; allocate real mode callback


        sub esp,32                      ; stack space for register structure
        mov edi,esp                     ; EDI = offset of register structure

        mov dword ptr [esp+2eh],0       ; SS:SP = 0 in register structure
	mov [esp+2ah],dx                ; IP is offset of real mode callback
        mov [esp+2ch],cx                ; CS is segment of real mode callback
        mov word ptr [esp+20h],0        ; zero FLAGS in register structure

        xor cx,cx                       ; no parameters on stack
        xor bh,bh                       ; BH must be 0
        mov ax,301h                     ; INT 31h function 0301h

        int 31h                         ; call real mode callback


        add esp,64                      ; free stack space

        mov ah,4ch                      ; exit to DOS
        int 21h

;
callback:
        cld
	lods dword ptr ds:[esi]         ; get return seg:off from real mode
	mov dword ptr es:[edi+2ah],eax  ;  stack, and update return address
        add word ptr es:[edi+2eh],4     ; adjust SP in register structure

	push es edi                     ; preserve register structure ES:EDI


	mov es,cs:dataselector          ; ES = main stream data selector

	mov edi,offset V86_edi     ; offset of register structure
	xor cx,cx                       ; no parameters on stack
        mov bx,21h                      ; call interrupt 21h
        mov ax,300h                     ; INT 31h function 0300h

	mov es:V86_dx,offset msg1  ; offset of new string, other fields
                                        ;  were set previously
	int 31h                         ; do the call to real mode


	xor ah,ah                       ; wait for keypress
	int 16h


	pop edi es                      ; restore register structure ES:EDI

	iretd                           ; done with callback

CODE16           ends




;
;   GOMEZ   32BIT PROTECTED MODE KERNEL
;
;
;  Now here begins the 32-bit area...
;  First come some data-fields that are also used by the 16bit code
;  Note that these datas may NOT exceed 64k, because if they did, they were
;  not accessable any more from real-mode !
;
code32  segment para public use32
	assume cs:code32, ds:code32
	largestack
	org 0

PUBLIC C LIN_Selector   ,C CODE16_Selector ,C DATA16_Selector ,C CODE32_Selector
PUBLIC C DATA32_Selector,C STACK32_Selector
PUBLIC C LIN_Address    ,C CODE16_Address  ,C CODE32_Address  ,C DATA16_Address
PUBLIC C DATA32_Address ,C STACK32_Address ,C PSP_Address
PUBLIC C GOMEZ_Flags    ,C GOMEZ_System

PUBLIC C V86_EAX	,C V86_AX	,C V86_AL	,C V86_AH
PUBLIC C V86_EBX	,C V86_BX	,C V86_BL	,C V86_BH
PUBLIC C V86_ECX	,C V86_CX	,C V86_CL	,C V86_CH
PUBLIC C V86_EDX	,C V86_DX	,C V86_DL	,C V86_DH
PUBLIC C V86_ESI	,C V86_SI
PUBLIC C V86_EDI	,C V86_DI
PUBLIC C V86_EBP	,C V86_BP
PUBLIC C V86_ESP	,C V86_SP
PUBLIC C V86_ES		,C V86_FS	,C V86_GS	,C V86_DS
PUBLIC C V86_FLAGS

PUBLIC C Init_PMODE32   ,C Exit_PMODE32	   ,C Switch_to_RM    ,C Switch_to_PM
PUBLIC C Set_Real_Interrupt	,C Get_Real_Interrupt
PUBLIC C Set_Flat_Interrupt	,C Get_Flat_Interrupt
PUBLIC C Set_Flat_Exception	,C Get_Flat_Exception
PUBLIC C Set_Flat_IRQ	  	,C Get_Flat_IRQ
PUBLIC C Link_Real_IRQ	   	,C Unlink_Real_IRQ
PUBLIC C Invoke_Real_Int   	,C Invoke_Real_IRQ
PUBLIC C Call_Real_Proc	   	,C Call_Real_Int

PUBLIC C Print32

PUBLIC C Malloc		,C Free		,C Page_Malloc	,C Realloc
PUBLIC C DMA_Malloc	,C Coreleft 	,C Get_Size
PUBLIC C DOS_Malloc	,C DOS_Free	,C DOS_Coreleft
PUBLIC C DOS_DMA_Malloc
PUBLIC C Alloc_Selector ,C Free_Selector

PUBLIC C Open		,C Close	,C Read		,C Write
PUBLIC C Creat		,C Tell		,C Seek		,C Chsize
PUBLIC C Getchar	,C Putchar	,C FindFile	,C Chdir

EXTRN  C main:NEAR

	;
	;First for some selector & address crap...
	;
	ALIGN 	DWORD
	LIN_Selector		dd	?
	CODE16_Selector		dd	?
	DATA16_Selector		dd	?
	CODE32_Selector		dd	?
	DATA32_Selector		dd	?
	STACK32_Selector	dd	?

	LIN_Address		dd	0
	CODE16_Address		LABEL DWORD
	DATA16_Address		dd	?
	CODE32_Address		LABEL DWORD
	DATA32_Address		dd	?
	STACK32_Address		dd	?
	PSP_Address		dd	?

	IO_Buffer		dd	?

	GOMEZ_Flags		dd	EXIT_ON_RESET or VERBOSE_PAUSE
	GOMEZ_System		dd	0

	ALIGN 	DWORD
	V86_EDI    	label   dword
	V86_DI     	dw      ?,?
	V86_ESI    	label   dword
	V86_SI     	dw      ?,?
	V86_EBP    	label   dword
	V86_BP     	dw      ?,?
			dd      ?
	V86_EBX    	label   dword
	V86_BX     	label   word
	V86_BL     	db      ?
	V86_BH     	db      ?,?,?
	V86_EDX    	label   dword
	V86_DX     	label   word
	V86_DL     	db      ?
	V86_DH     	db      ?,?,?
	V86_ECX    	label   dword
	V86_CX     	label   word
	V86_CL     	db      ?
	V86_CX     	db      ?,?,?
	V86_EAX    	label   dword
	V86_AX     	label   word
	V86_AL     	db      ?
	V86_AH     	db      ?,?,?
	V86_FLAGS  	dw      ?
	V86_ES     	dw      ?
	V86_DS     	dw      ?
	V86_FS     	dw      ?
	V86_GS     	dw      ?
	V86_IP     	dw      ?
	V86_CS     	dw      ?
	V86_SP     	dw      ?
	V86_SS     	dw      ?

;
;   GOMEZ   				32BIT INIT CODE
;
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]	;Load FS and GS with linear
	mov	fs,ds:[LIN_Selector]	;  selectors. DS is already loaded
	mov	gs,ds:[LIN_Selector]	;  with DATA32_Selector

	sti
	YES_NMI

	jmp     main


;
;   GOMEZ   				32BIT EXIT CODE
;
Exit_PMODE32:
	cld
	cli
	mov ah,4ch                      ; exit to DOS
	int 21h
code32 ends


;
;   GOMEZ   				16BIT STACK SEGMENT
;
EXE_STACK       segment para stack use16 'STACK'
		db      STACKLEN*10h dup(?)
EXE_STACK       ends
end     start

